      program fetching
      implicit integer*2 (a-z)
      parameter nsz=17, nszsq=nsz**2
      character*100 name
      logical found
      common /intrnl/ lu1,lu2,lu3 /compar/ iod(nszsq)
      call lib$init_timer
      lu1 = 5
      lu2 = 6
      lu3 = 10
10    type '(a)','$Which file? '
      accept '(a)',name
      inquire (file=name,exist=found,recl=lrecl,err=10)
      if (.not.found) go to 10
      type *,'The reported LRECL is',lrecl
      open (unit=lu3,file=name,status='old',readonly,err=10)
      type '(a)','$Enter last record to include : '
      accept *,last_record
      call fetch (lrecl,6,10,-1)
      lowrow = 500
      hirow  = lowrow + 16
      do i = 1,last_record,10
         lowcol = i
         hicol  = lowcol + 14
         call fetch (lowcol,hicol,lowrow,hirow)
         if (mod(i,100).eq.1) then
            write (*,*) lowcol,hicol,lowrow,hirow
            write (*,*) (iod(j),j=100,110)
         end if
      end do
      call lib$show_timer (,,,)
      call fetch (0,0,0,-999)
      stop
      end
      subroutine fetch (lowcol,hicol,lowrow,hirow)
      implicit integer*4 (a-z)
C
      parameter nsz=17, nbufs=2600
      parameter nszsq=nsz*nsz
      parameter sec$m_crf    = '00000002'x
      parameter sec$m_expreg = '00020000'x
      parameter ss$_vasfull  = '00000244'x
c
      common /sec_data/ chan,lrecl,numrecs
      integer*4 maprange(2),retaddr(2)
      character*150 name
      byte buffrs(1)
c
      integer*2 iod,lu1,lu2,lu3,lowcol,hicol,lowrow,hirow
      logical*1 initialize
      common / compar / iod(nszsq)     !nszsq = nsz ** 2
      common / intrnl / lu1,lu2,lu3
      dimension buf2d(nbufs),iod2d(nsz)
      data initialize/.true./,io/0/
      if(hirow.ge.0) go to 15
      if(hirow.lt.-100) go to 999
c     if here, initialize the subroutine
      lu2=hicol
      lu3=lowrow
      if(initialize) then
c
c     open the film image as a private section file and map to it
c     asking for the entire file even though it might not fit.
c     When we get the mapping, we'll back off a bit if necessary.
c
c     open the file
c
	 inquire (unit=lu3,name=name)
         status = open_sec_file(name)
	 type *,'lrecl =',lrecl
	 type *,'numrecs =',numrecs
         if (.not.status) then
	    call lib$signal(%val(status))
            stop 'Error opening section file'
         end if
	 if (numrecs.eq.-1) then
	    stop 'Error: the file does not have fixed length records'
	 end if
	 if (lrecl.eq.0) then
	    stop 'Error: the LRECL for the file is not available'
	 end if
c
c     create the private section and do a preliminary mapping
c
         maprange(1) = '00000200'x
         maprange(2) = '00000200'x
	 fault_size = lrecl/512+2
         status = sys$crmpsc(maprange,retaddr,,
     1    %val(sec$m_crf.or.sec$m_expreg),,,,
     2    %val(chan),,,,,%val(fault_size))
	 type *,retaddr
	 maprange(1) = retaddr(1)
	 maprange(2) = retaddr(2)
         if (.not.status) then
            if (status.eq.ss$_vasfull) then  ! try again
	       status = sys$deltva(retaddr,,) ! kill what we had
	       if (.not.status) then
		  call lib$signal(%val(status))
		  stop 'Error releasing virtual space'
	       end if
c
c	       reopen the file
c
	       status = open_sec_file(name)
               if (.not.status) then
	          call lib$signal(%val(status))
                  stop 'Error reopening section file'
               end if
c
c	       remove 1/8 of space allocated
c
	       maprange(2) = retaddr(2) - (retaddr(2)-retaddr(1))/8
               status = sys$crmpsc(maprange,retaddr,,
     1          %val(sec$m_crf),,,,%val(chan),,,,,
     2          %val(fault_size))
	       type *,retaddr
               if (.not.status) then	! too bad
	          call lib$signal(%val(status))
                  stop 'Error mapping in initialization (2)'
               end if
            else           		! too bad
	       call lib$signal(%val(status))
               stop 'Mapping error in initialization'
            end if
         end if
c
         initialize = .false.
	 offset = retaddr(1) - %loc(buffrs(1))
	 main_offset = offset
	 span   = retaddr(2) - retaddr(1)
	 records_held = (span+1)/lrecl
	 base_record = 1
	 remap = 0
c
c        initialize 2 dimensional indexing biases and pointers
c
         do i=1,nsz
            iod2d(i)=nsz*(i-1)
         end do
         do i=1,nbufs
            buf2d(I)=lrecl*(i-1)
         end do
      end if
      if (abs(lowcol-lrecl).gt.8) then
         write (6,*) 'LOWCOL=',lowcol,'.NE. LRECL=',lrecl
         write (6,*) 'WHEN INITIALIZING FETCH. PROGRAM ERROR'
         stop 'FETCH ERROR'
      end if
c
      return
c
c        normal call
c
c     entry fetch (lowcol,hicol,lowrow,hirow)
   15 continue
      if (lowrow.lt.1 .or. hirow.gt.lrecl) then
	 stop 'Error: reading data beyond span of record'
      end if
      if (lowcol.lt.1 .or. hicol.gt.numrecs) then
	 stop 'Error: reading data beyond span of file'
      end if
      do column=lowcol,hicol
         if (column.lt.base_record .or.
     1		%loc(buffrs(1))+buf2d(column+1)+offset-1
     2		.gt.retaddr(2)) then
	    type *,'Require remapping for', column
c
c	    we have to remap
c
c	    where is the next record?
c
c	    adjust the desired column considering the number
c	    of records that can fit in memory as well as the
c	    recent history of records used (last one, for now)
c
	    if (column.lt.base_record) then
	       column_wanted = max(1,column-records_held/3)
	    else
	       column_wanted = column
	    end if
	    column_wanted = min(column_wanted,numrecs-records_held+1)
c
	    vbn = buf2d(column_wanted)/512 + 1
c
	    status = sys$crmpsc(maprange,retaddr,,%val(sec$m_crf),,,,
     1			%val(chan),,%val(vbn),,,%val(fault_size))
	    if (.not.status) then
	       call lib$signal(%val(status))	
	       stop 'Error remapping to vbn'
	    end if
	    remap = remap + 1
	    base_record = column_wanted
	    offset = main_offset - buf2d(base_record)
	 end if
c
c        the desired record is in memory,
c	 copy appropriate rows into iod
c
	 bfbias = offset + buf2d(column)
         iodcol=column-lowcol+1
         odbias=iod2d(iodcol)-lowrow+1
         do row=lowrow,hirow
            iod(odbias+row) = zext(buffrs(bfbias+row))
         end do
c
c        continue loop over columns
c
      end do
c
      return
c
c     closing call
c
  999 continue
      status = sys$deltva(retaddr,,) ! kill what we had
      if (.not.status) then
	 call lib$signal(%val(status))
	 stop 'Error releasing virtual space'
      end if
      write (lu2,105) remap
  105 format ('0FETCH REMAPPED',i6,' TIMES.'/)
      return
      end
