$	VFL='F$VERIFY(0)'
$	SET ON
$	ON CONTROL_Y THEN GOTO END
$!
$!	Command procedure to make FLECS look like a language
$!	processor known to the system.
$!
$!	The first parameter is the FLECS file name.
$!	The second parameter is the FORTRAN file name.
$!	The third parameter is the LISTING file name.
$!
$!	If the file type of the first parameter is not
$!	specified, it defaults to ".FLX".
$!
$!	If the second parameter is null or the file type of
$!	the first parameter is ".FLX" (either explicitly or
$!	by default) the FORTRAN file name is set the same as
$!	the FLECS file name but with a file type of ".FOR"
$!	residing in the default device and directory.  If the
$!	parameter is null and the first parameter file type
$!	is not ".FLX", a prompt is issued.
$!
$!	If the third parameter is null and the file type of
$!	the first parameter is ".FLX" the LISTING file name is
$!	set the same as the FLECS file name but with a file
$!	type of ".FLL" residing in the default device and
$!	directory.  If the parameter is null and the first
$!	parameter file type is not ".FLX", a prompt is issued.
$!
$P1CHK:	IF P1 .NES. "" THEN GOTO PARSE
$	INQUIRE/NOPUNCTUATION P1 "_From:	"
$	GOTO P1CHK
$!
$PARSE:
$!
$!	Replace P1 by the fully quallified name of the input file
$!
$	PP = F$PARSE(P1,".FLX")	! Supply ".FLX" as a default
$!
$!	Does this file actually exist?
$!
$	IF PP.EQS."" THEN GOTO NOP1
$	P1 = PP			! In case we need it for the message below
$	PP = F$SEARCH(PP)
$	IF PP.NES."" THEN GOTO P1DONE
$NOP1:
$	WRITE SYS$OUTPUT "''F$MESSAGE(%X912)': ''P1'"
$	GOTO END
$!
$P1DONE:P1 = PP
$	P1N = F$PARSE(P1,,,"NAME")
$	P1T = F$PARSE(P1,,,"TYPE")
$!
$!	Now check the second parameter which names the FORTRAN file
$!
$	IF P1T.NES.".FLX" .AND. P2.EQS."" THEN -
		INQUIRE/NOPUNCTUATION P1N "_To:  	"
$	P2 = F$PARSE(P2,"''P1N'.FOR")
$!
$!	Now check the third parameter which names the LISTING file
$!
$	IF P1T.NES.".FLX" .AND. P3.EQS."" THEN -
		INQUIRE/NOPUNCTUATION P1N "_List:	"
$	P3 = F$PARSE(P3,"''P1N'.FLL")
$!
$RUNIMAGE:
$	ASSIGN/USER_MODE	'P1'	FOR001
$	ASSIGN/USER_MODE	'P2'	FOR002
$	ASSIGN/USER_MODE	'P3'	FOR003
$	ON ERROR THEN CONTINUE
$	RUN	X$:FLECS
$END:
$	IF VFL.EQ.1 THEN SET VERIFY
