	LOGICAL FUNCTION INTERACTIVE_INPUT

	IMPLICIT INTEGER (A-Z)

	PARAMETER ( PCB$V_BATCH = 'E'X )

	CHARACTER*63 PHYSICAL_NAME
	LOGICAL PERMANENT

	COMMON /USER_DATA_/ PID,PROC_STAT

	CALL TRNLOG('SYS$INPUT',PHYSICAL_NAME,NAME_LEN,PERMANENT)

	INTERACTIVE_INPUT=INDEX(PHYSICAL_NAME,'TT').NE.0 .OR.
	1				INDEX(PHYSICAL_NAME,'OP').NE.0

	RETURN


	ENTRY INTERACTIVE_OUTPUT

	CALL TRNLOG('SYS$OUTPUT',PHYSICAL_NAME,NAME_LEN,PERMANENT)

	INTERACTIVE_OUTPUT=INDEX(PHYSICAL_NAME,'TT').NE.0 .OR.
	1				INDEX(PHYSICAL_NAME,'OP').NE.0

	RETURN


	ENTRY BATCH_MODE

	CALL USER_HAS_PRIV(' ')

	BATCH_MODE = IAND(PROC_STAT,ISHFT(1,PCB$V_BATCH)) .NE. 0

	END
	LOGICAL FUNCTION USER_HAS_PRIV( PRIV_NAME )

*
*	LOGICAL FUNCTION USER_HAS_PRIV( PRIV_NAME )
*
*	This function returns a value of .TRUE. if this process
*	has the named privilege (passed as a character string), or
*	returns a value of .FALSE. if this process does not have
*	the privilege or if the name is not the name of a known
*	privilege.
*
*	In addition, other information about this process is returned
*	in common /USER_DATA_/:
*
*	    The PID, process status flags, UIC (longwords),
*
*	    The process name, terminal name (if any), user name (strings),
*
*	    The lengths of the valid parts of the name strings (words).
*
*
*	Alan L. Zirkle     Naval Surface Weapons Center
*			   Code K105
*	(703) 663-7815	   Dahlgren, Virginia  22448
*
*		   August 19, 1983
*

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) PRIV_NAME
	CHARACTER*6 PRIV
	CHARACTER*186 PRIVS

	INTEGER*4 PID,PROC_STAT,UIC
	CHARACTER*16 PROCNAME
	CHARACTER*8 TERMNAME
	CHARACTER*12 USERNAME
	INTEGER*2 PNLEN,TNLEN,UNLEN

	COMMON /USER_DATA_/ PID,PROC_STAT,UIC,PROCNAME,TERMNAME,USERNAME,
	1				       PNLEN,   TNLEN,   UNLEN

	PARAMETER ( JPI$_PID      = '319'X )
	PARAMETER ( JPI$_PRCNAM   = '31C'X )
	PARAMETER ( JPI$_PROCPRIV = '204'X )
	PARAMETER ( JPI$_STS      = '305'X)
	PARAMETER ( JPI$_TERMINAL = '31D'X )
	PARAMETER ( JPI$_UIC      = '304'X )
	PARAMETER ( JPI$_USERNAME = '202'X )

	PARAMETER ( ITMLST1 = JPI$_PID     *2**16+4 )
	PARAMETER ( ITMLST4 = JPI$_PRCNAM  *2**16+16)
	PARAMETER ( ITMLST7 = JPI$_PROCPRIV*2**16+4 )
	PARAMETER ( ITMLST10= JPI$_STS     *2**16+4 )
	PARAMETER ( ITMLST13= JPI$_TERMINAL*2**16+8 )
	PARAMETER ( ITMLST16= JPI$_UIC     *2**16+4 )
	PARAMETER ( ITMLST19= JPI$_USERNAME*2**16+12)

	INTEGER*4 ITMLST(28) / ITMLST1,0,0,ITMLST4,0,0,ITMLST7,0,0,
	1	ITMLST10,0,0,ITMLST13,0,0,ITMLST16,0,0,ITMLST19,0,0,
	2	0,0,0, 0,0,0, 0 /

	COMMON /USER_PRIV_/ ITMLST

*	ITMLST(22) through ITMLST(27) can be set by the calling program
*	before the first call to USER_HAS_PRIV, to get additional data
*	about the process.

	INTEGER*4 PRIVILEGES
	LOGICAL*1 FIRST_CALL / .TRUE. /

      DATA PRIVS/'CMKRNLCMEXECSYSNAMGRPNAMALLSPODETACHDIAGNOLOG_IOGROUP 
     1ACNT  PRMCEBPRMMBXPSWAPMALTPRISETPRVTMPMBXWORLD MOUNT OPER  EXQUOT
     2NETMBXVOLPROPHY_IOBUGCHKPRMGBLSYSGBLPFNMAPSHMEM SYSPRVBYPASSSYSLCK
     3'/

	IF (FIRST_CALL) THEN

	    FIRST_CALL = .FALSE.

	    ITMLST(2)  = %LOC(PID)
	    ITMLST(5)  = %LOC(PROCNAME)
	    ITMLST(6)  = %LOC(PNLEN)
	    ITMLST(8)  = %LOC(PRIVILEGES)
	    ITMLST(11) = %LOC(PROC_STAT)
	    ITMLST(14) = %LOC(TERMNAME)
	    ITMLST(15) = %LOC(TNLEN)
	    ITMLST(17) = %LOC(UIC)
	    ITMLST(20) = %LOC(USERNAME)

	    STATUS = SYS$GETJPI(,,,ITMLST,,,)

	    IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

	    IF (INDEX(USERNAME,' ').NE.0) THEN
		UNLEN=INDEX(USERNAME,' ')-1
	    ELSE
		UNLEN=12
	    ENDIF

	ENDIF

	PRIV = PRIV_NAME

	I = INDEX(PRIVS,PRIV)

	IF (MOD(I,6).NE.1) GO TO 100

	IF (PRIVS(I:I+5).NE.PRIV) GO TO 100

	USER_HAS_PRIV = IAND(PRIVILEGES,ISHFT(1,I/6)) .NE. 0

	RETURN

100	USER_HAS_PRIV = .FALSE.

	END
	SUBROUTINE GET_A_FILE_NAME(PARAM_NAME,FILE_NAME,NAME_LEN,
	1						DEFAULT_NAME,*,*)

*
*	SUBROUTINE GET_A_FILE_NAME
*
*	Processes a DCL parameter value which is a file name or a list of
*	file names (separated by commas).  The name(s) may contain wild
*	card characters.  Each time this subroutine is called, it returns
*	the actual name of one file which matches the parameter value.
*	When no more matches are found, an alternate return is taken.
*
*	Another alternate return is taken if no files are found which match
*	the value.  If the value is a list, this return is taken each time
*	no files are found which match the current list element being exam-
*	ined; subsequent calls to GET_A_FILE_NAME will check succeeding
*	list elements.  (Thus when this second alternate return is taken,
*	you may print a diagnostic message if you desire, but you should 
*	continue calling this subroutine until the first alternate return
*	is taken.
*
*	Common /GET_FILE_NAME/ contains the current parameter list item
*	being examined.
*
*	The required arguments to GET_A_FILE_NAME are:
*
*	    PARAM_NAME  ----  Name of the DCL parameter to be examined.
*			      See Chapter 5 of the VAX-11 Utilities Ref-
*			      erence manual.  This is a character string
*			      input to GET_A_FILE_NAME.
*
*	    FILE_NAME  -----  Actual name of one file which matches the
*			      parameter value.  This is a character string
*			      output from GET_A_FILE_NAME.
*
*	    NAME_LEN  ------  Length of non-blank part of FILE_NAME.  This
*			      is an integer output from GET_A_FILE_NAME.
*
*	    DEFAULT_NAME  --  Blank, or a default name to be used in deter-
*			      mining FILE_NAME when the parameter value is
*			      an incomplete file specification.  This is a
*			      character string input to GET_A_FILE_NAME.
*
*	    * (RETURN 1)  --  Statement label in the calling routine which
*			      is returned to (instead of the statement immed-
*			      iately following the call to GET_A_FILE_NAME)
*			      when no more files exist which match the param-
*			      eter value.
*
*	    * (RETURN 2)  --  Statement label in the calling routine which
*			      is returned to when no files are found to match
*			      one element of the parameter value list (or the
*			      entire value if it is not a list).  The calling
*			      routine may print a diagnostic message if desir-
*			      ed, but should continue calling GET_A_FILE_NAME.
*
*
*	Alan L. Zirkle     Naval Surface Weapons Center
*			   Code K105
*	(703) 663-7815	   Dahlgren, Virginia  22448
*
*		   May 11, 1983
*

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) PARAM_NAME,FILE_NAME,DEFAULT_NAME
	CHARACTER PARAM_VALUE*128,RELATED_NAME*128
	LOGICAL WITHIN,FOUNDONE

	COMMON /GET_FILE_NAME/ PARAM_LEN,PARAM_VALUE

	DATA WITHIN,RELATED_NAME / .FALSE. , ' ' /

10	IF (.NOT.WITHIN) THEN

	    STATUS=CLI$GET_VALUE(PARAM_NAME,PARAM_VALUE)

	    IF (.NOT.STATUS) THEN

		RELATED_NAME = ' '

		RETURN 1

	    ENDIF

	    CALL STR$TRIM(PARAM_VALUE,PARAM_VALUE,PARAM_LEN)

	    WITHIN   = .TRUE.
	    FOUNDONE = .FALSE.

	    CONTEXT=0

	ENDIF

	STATUS=LIB$FIND_FILE(PARAM_VALUE,FILE_NAME,CONTEXT,
	1					DEFAULT_NAME,RELATED_NAME)

	IF (.NOT.STATUS) THEN

	    WITHIN=.FALSE.

	    IF (.NOT.FOUNDONE) RETURN 2

	    GO TO 10

	ENDIF

	CALL STR$TRIM(RELATED_NAME,FILE_NAME,NAME_LEN)

	FOUNDONE = .TRUE.

	END
      subroutine trnlog(lognam,devnam,dvsize,permdv)
c
C     FROM DECUS FALL 81 TAPE, FILE [VAX81B.MUDD.TRNLOG]TRNLOG.FOR  (A.Z.)
C
c     this subroutine will convert the logical name
c     lognam into the final device name using the
c     system service routine sys$trnlog until there
c     is no more change in the name.
c
      logical permdv
      integer i,dvsize
      integer sys$trnlog
      character*(*) lognam,devnam
      character*64 name1,name2
c
      parameter ss$_normal = 1
      parameter ss$_notran = '00000629'x
c
      permdv = .false.
      len1 = min(63,len(lognam))
      name1 = lognam(1:len1)
c
c     convert the name until ss$_notran is returned
c
10    i = sys$trnlog(name1(1:len1),len2,name2,,,)
      if (name2(len2:len2).eq.':') len2 = len2-1
d     type 2000,name1(1:len1),name2(1:len2),len1,len2,i
d2000 format(' from = ',a,/,' to = ',a,/,' length = ',i5,'/',i5,
d    1'  error status = ',z8)
      if (i.eq.ss$_normal) goto 20
      if (i.ne.ss$_notran) goto 100
      dvsize = min(len(devnam),len2)
      devnam = name2(1:dvsize)
      if (ichar(name2(1:1)).ne.'1B'X) goto 200
      if (ichar(name2(2:2)).ne.0) goto 200
      dvsize = dvsize-4
      devnam = name2(5:len2)
      permdv = .true.
      goto 200
c
20    i = sys$trnlog(name2(1:len2),len1,name1,,,)
d     type 2000,name2(1:len2),name1(1:len1),len1,len2,i
      if (name1(len1:len1).eq.':') len1 = len1-1
      if (i.eq.ss$_normal) goto 10
      if (i.ne.ss$_notran) goto 100
      dvsize = min(len(devnam),len1)
      devnam = name1(1:dvsize)
      if (ichar(name1(1:1)).ne.'1B'X) goto 200
      if (ichar(name1(2:2)).ne.0) goto 200
      dvsize = dvsize-4
      devnam = name1(5:len1)
      permdv = .true.
      goto 200
c
c     on erroneous return code, bomb out nicely
c
100   continue
c
c     all done, return
c
200   return
      end
