$! This command procedure prints a calendar for the year specified.  The
$!	year can be stated on the command line as a parameter or the
$!	procedure will inquire for it.  A calendar can be printed for
$!	the years 1981 thru 1983.  Minor modifications will allow the
$!	creation of calendars for other years.
$!
$!
$!
$! Set up symbols to be used 
$!
$!
$MONTHSTR:= "7JANUARY8FEBRUARY5MARCH5APRIL3MAY4JUNE4JULY7AUGUST"-
	    "9SEPTEMBER7OCTOBER8NOVEMBER8DECEMBER0"
$START=0
$LEN=0
$HEADER0:= ""
$HEADER2:= " "
$HEADER3:= "       SUNDAY            MONDAY            TUESDAY"-
	   "         WEDNESDAY         THURSDAY          FRIDAY            "-
	   "SATURDAY"
$HEADER4:= "------------------"
$HEADER6:= "!                 "
$!
$!
$!
$!
$! Get and validate year
$!
$!
$IF P1.EQS." " THEN $INQUIRE P1 "ENTER TWO DIGIT CALENDAR YEAR TO BE "-
		     "PRODUCED "
$YEAR=''P1'
$IF YEAR.GE.81 .AND. YEAR.LE.83 THEN GOTO SETUP
$WRITE SYS$OUTPUT "CALENDAR CAN ONLY BE PRODUCED FOR YEARS 81 THRU 83"
$EXIT
$!
$!
$!
$!
$! See if a calendar needs to be generated   
$!
$!
$SETUP:
$OPEN/ERROR=SETUP2 CALENDAR CALEND'YEAR'.DAT     !See if a calendar exists
$WRITE SYS$OUTPUT "A calendar exists for the year ''YEAR'"
$INQUIRE/NOPUNC ANS "Shall I print it? "
$IF ANS THEN GOTO FINISHED			 !Close file and print calendar
$CLOSE CALENDAR 			 	 !Close file 
$!
$!
$!A calendar needs to be generated
$!
$!
$SETUP2:
$OPEN/WRITE/ERROR=OPEN_ERROR CALENDAR CALEND'YEAR'.DAT
$WRITE SYS$OUTPUT "GENERATING CALENDAR"
$GOTO SETUP'YEAR'				 !Set up for appropriate year
$!
$!
$!
$! Set up first week of the year     (THIS BLOCK OF CODE MUST BE CHANGED
$!				      TO CHANGE THE YEARS)
$!      DAY is used for computation; PDAY is used for printing
$
$SETUP81:
$	DAY1==28		
$	PDAY1:==28	     !Sunday
$	DAY2==29		
$	PDAY2:==29	     !Monday
$	DAY3==30		
$	PDAY3:==30	     !Tuesday
$	DAY4==31	
$	PDAY4:==31	     !Wednesday
$	DAY5==1		
$	PDAY5:==" 1"	     !Thursday
$	DAY6==2		
$	PDAY6:==" 2"	     !Friday
$	DAY7==3		
$	PDAY7:==" 3"	     !Saturday
$GOTO SETUPMONTH
$!
$SETUP82:
$!
$	DAY1==27
$	PDAY1:==27	     !Sunday
$	DAY2==28		
$	PDAY2:==28	     !Monday
$	DAY3==29		
$	PDAY3:==29	     !Tuesday
$	DAY4==30	
$	PDAY4:==30	     !Wednesday
$	DAY5==31		
$	PDAY5:==31	     !Thursday
$	DAY6==1	
$	PDAY6:==" 1"	     !Friday
$	DAY7==2		
$	PDAY7:==" 2"	     !Saturday
$GOTO SETUPMONTH
$!
$SETUP83:
$	DAY1==26
$	PDAY1:==26	     !Sunday
$	DAY2==27		
$	PDAY2:==27	     !Monday
$	DAY3==28		
$	PDAY3:==28	     !Tuesday
$	DAY4==29	
$	PDAY4:==29	     !Wednesday
$	DAY5==30		
$	PDAY5:==30	     !Thursday
$	DAY6==31		
$	PDAY6:==31	     !Friday
$	DAY7==1		
$	PDAY7:==1	     !Saturday
$!
$!
$!
$!
$!
$!
$!
$!
$!
$! In this section we will get a month from MONTHSTR (list of all months),
$! 	determine the number of days in that month (LASTDAY) and then
$!	print each week within that month
$!
$!
$SETUPMONTH:
$!
$	NUMBER_OF_WEEKS == 0		  !Number of weeks in month
$	NEWMONTH=0			  !Signals new month starting
$	START=START+LEN		 	  !Offset of length within MONTHSTR
$	LEN='F$EXTRACT(START,1,MONTHSTR)  !Length of month name string
$	IF LEN.EQ.0 THEN $GOTO FINISHED   !0 indicates all months printed
$	START=START+1			  !Point to month name string
$	MONTH:=='F$EXTRACT(START,LEN,MONTHSTR)
$!
$!
$!	Set up number of days contained in this month
$!
$	MON:='F$EXTRACT(0,3,MONTH)        !First 3 chars of month name string
$	LASTDAY==31			  !Assume 31 days in month
$	IF MON.EQS."SEP" .OR. MON.EQS."APR" .OR. MON.EQS."JUN" -
		.OR. MON.EQS."NOV"  THEN LASTDAY==30
$	IF MON.EQS."FEB" THEN LASTDAY==28
$	IF MON.EQS."FEB" .AND. YEAR.EQ.84 THEN LASTDAY==29
$!
$!
$!
$!	Now we are ready to print calendar for this month
$!	   Start by printing headers
$!
$	WRITE CALENDAR HEADER0
$	WRITE CALENDAR "                                                      ",-
	   "''MONTH'   19''YEAR' "
$	WRITE CALENDAR HEADER2
$	WRITE CALENDAR HEADER3
$	WRITE CALENDAR HEADER4,HEADER4,HEADER4,HEADER4,HEADER4,HEADER4,HEADER4-
	   ,"-"
$!
$!
$!
$!	Now use PRINTWEEK to print the first week of the month
$!
$	@PRINTWEEK
$!
$!
$!
$!	Set up and print remainder of month via PRINTMONTH
$!
$	@PRINTMON
$!
$!
$!
$!	Finished with this month - get the next
$!
$GOTO SETUPMONTH		      !LOOP
$!
$!
$!
$!
$!
$!
$!
$! Error routine
$!
$OPEN_ERROR:
$	WRITE SYS$OUTPUT "UNABLE TO OPEN OUTPUT FILE - ABORTING"
$	EXIT
$!
$!
$!
$!
$!
$! All done - print calendar on printer and cleanup
$!
$FINISHED:
$	CLOSE CALENDAR
$	PRINT/NOFEED CALEND'YEAR'.DAT
$EXIT
