$!DISKUSG.COM	-	Command procedure that calls an image DISKUSG.EXE 
$!			to calculate and print the blocks used by
$!			all user and sub file directories on the 
$!			specified disk. Directories with number pair
$!			names are ignored.
$!
$!			ANALYZE/DISK_STRUCTURE/USAGE is used to produce
$!			a usage file USAGE_DIR:USAGE.DAT.
$!
$!			SYS$MANAGER:DISKUSG.MAR is called to read the usage
$!			file and produce USAGE_DIR:DISKUSAGE.LIS.
$!
$!			PARAMETERS:
$!			    P1 - DISK from which the report will be produced.
$!			    P2 - ""       :  ==> PRINT and DELETE the usage report
$!				 "N" or "n : ==> PRINT and keep the usage report
$!
$!
$!			NECESSARY FILES:
$!					DISKUSG.COM
$!					SYS$MANAGER:DISKUSG.EXE
$!
$!			SOURCE FILE:
$!					DISKUSG.MAR
$!
$!
$!		Written by:	Scott Stuart
$!				Educational Services
$!				Digital Equipment Corporation
$!				July 20, 1983
$!
$!
$!
$!Setup
$!
$!
$! Check for parameter - if not interactiv then don't prompt
$!
$	IF   P1.EQS.""   .AND.   F$MODE().NES."INTERACTIVE" -
		 THEN EXIT
$!
$	SET NOON
$	ON CONTROL_Y THEN GOTO CTRL_Y_HDLR
$!
$!
$! Check for the definition of the logical name USAGE_DIR
$! It is used in the program to produce the output file.
$! Use the default directory if its not defined.
$!
	IF F$LOGICAL("USAGE_DIR") .EQS. "" 	-
	   THEN 				-
		ASSIGN  'F$DIRECTORY()'    USAGE_DIR
$!
$!
$!Determine which disk
$!
$	IF P1 .NES. "" THEN GOTO COLON_CHECK
$	INQUIRE P1 "Which disk? "
$COLON_CHECK:
$	LAST = 'F$LENGTH(P1)' - 1
$	IF "''F$EXTRACT(LAST,1,P1)'" .NES. ":" THEN P1 := 'P1'":"
$!
$!
$!  Set up the logical name USAGE_DISK
$!
$	ASSIGN	'P1'	USAGE_DISK
$!
$! Produce the usage file USAGE.DAT
$!
$!
$	ANALYZE/DISK_STRUCTURE/USAGE=USAGE_DIR:USAGE.DAT	USAGE_DISK:
$!
$!
$!
$!
$! Call SYS$MANAGER:DISKUSG.MAR to produce USAGE_DIR:DISKUSAGE.LIS
$!
$!
$	RUN SYS$MANAGER:DISKUSG.EXE
$!
$!
$!
$!  Print the listing file and delete the usage file
$!  Check for P2 = "NO". If it is then don't delete 
$!  the file, just print it.
$!
$	PFLAG	= "''P2'"
$	PFLAG	= F$EXTRACT (0,1,PFLAG)
$	IF PFLAG.EQS."N" .OR. PFLAG.EQS."n" THEN  GOTO NO_DELETE
$!
$!   else print and delete the file
$	PRINT/DELETE	USAGE_DIR:DISKUSAGE.LIS	
$	GOTO	CLEANUP
$!
$NO_DELETE:
$	PRINT	USAGE_DIR:DISKUSAGE.LIS	
$!
$CLEANUP:
$	DELETE		USAGE_DIR:USAGE.DAT;
$!
	DEASSIGN	USAGE_DIR
	DEASSIGN	USAGE_DISK
$!
$!If a batch job, stop without printing the log file
$!
$	IF "''F$MODE()'" .EQS. "BATCH" THEN STOP 'F$PROCESS()'
$!
$	EXIT
$!
$!
$!Control Y Handler
$!
$CTRL_Y_HDLR:
$	DELETE USAGE_DIR:DISKUSAGE.LIS;,USAGE.DAT;
