	PROGRAM USERS

*
*	Alan L. Zirkle     Naval Surface Weapons Center
*			   Code K105
*	August 1983	   Dahlgren, Virginia  22448
*

	IMPLICIT INTEGER (A-Z)

	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	BEGIN = .TRUE.

	CALL ENVIRONMENT

10	CALL INITIALIZE

	CHANGE = .FALSE.

	CALL DISPLAY1

	CALL DISPLAY2

	GO TO 10

	END
	SUBROUTINE DISPLAY1

	IMPLICIT INTEGER (A-Z)

*
*	THE PARAMETER 'LISTSIZE' MUST BE .GE.
*
*		3 + (NO. OF PORTS) + (MAX NO. OF BATCH JOBS)
*
*	(REMEMBER TO INCLUDE 'OPA0' AS A PORT)
*

	PARAMETER ( listsize = 61 )

	CHARACTER*63   LIST (listsize)
	INTEGER*2      LINK (listsize)
	INTEGER*4   LINE_NO (listsize)
	LOGICAL*1  EXAMINED (listsize)

	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128,IMAGE*23,DATA*63
	LOGICAL SYSTEM,CHANGE,START,END,BEGIN,NEW

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /DATALEN/  IMAGLEN,PROCLEN,PORTLEN,USERLEN
	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_1/ LIST
	COMMON /LIST_2/ LINK
	COMMON /LIST_3/ FREE,THIS,LAST,NEW
	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	EQUIVALENCE (DATA,PORT),(IMAG,IMAGE)

	DATA TOTAL,EXAMINED(1),EXAMINED(2) / 0,.TRUE.,.TRUE. /

	CALL LIST_INIT(listsize)

	LINE_NO(1)=2		! FIRST SCREEN LINE FOR DATA, MINUS ONE
	LINE_NO(2)=3		! INITIAL VALUE OF SCREEN LINE FOR BLANK LINE
				!  SEPARATING INTERACTIVE AND BATCH PROCESSES
	MAXL=3
	START=.TRUE.

10	DO I=3,listsize
	    EXAMINED(I)=.FALSE.
	ENDDO

	PIDADR=-1

20	CALL GET_DATA(PIDADR,*30)

	IF (PROCLEN.LT.16) PROC(PROCLEN+1:)=' '

	IF (IMAGLEN.GT.0) THEN

	    CALL GET_IMAGE(IMAGE)

	ELSE

	    IMAGE=' '

	ENDIF

	CALL LIST_LOOK_UP(DATA)

	EXAMINED(THIS)=.TRUE.

	IF (NEW) THEN						! NEW PORT

	    IF (SYSTEM) CALL ADD_PORT

	ELSE IF (DATA(1:40).NE.LIST(THIS)(1:40)) THEN

	    LIST(THIS)=DATA

	    CALL PRINT_LINE

	ELSE IF (IMAGE.NE.LIST(THIS)(41:)) THEN		! JUST IMAGE CHANGED

	    LIST(THIS)(41:)=IMAGE

	    CALL PRINT_IMAGE(IMAGE)

	ENDIF

	GO TO 20

30	IF (.NOT.SYSTEM) CALL SIMPLE_DISPLAY

	START=.FALSE.

	THIS=1

	DO WHILE (THIS.NE.0)

	    IF (.NOT.EXAMINED(THIS)) CALL DELETE_PORT

	    CALL LIST_SCAN

	ENDDO

	IF (CHANGE) RETURN

	IF (END) THEN

	    CALL LIB$ERASE_PAGE(23,1)		! Erase " ^ MORE v " if present

	    CALL LIB$SET_CURSOR(23,1)

	    CALL EXIT

	ENDIF

	CALL WAIT

	GO TO 10

	END
	SUBROUTINE ENVIRONMENT

	IMPLICIT INTEGER (A-Z)

	PARAMETER ( JPI$_IMAGNAME =  '207'X )
	PARAMETER ( DT$_VT100     =   '60'X )
	PARAMETER ( DT$_VT132     =   '66'X )

	CHARACTER*8 DEVNAME
	CHARACTER*128 THIS_IMAGE
	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC
	COMMON /THIS/ THIS_IMAGE,THIS_IMAGE_LEN
	COMMON /USER_PRIV_/ ITMLST(28)
	COMMON /TERMINAL_DATA_/ DEVNAME,DEVTYPE,DEPEND,DEPEND2,
	1			DEVNAMELEN

	DATA SYSTEM / .FALSE. /

	ITMLST(22) = IOR(ISHFT(JPI$_IMAGNAME,16),128)	! Set up for routine
	ITMLST(23) = %LOC(THIS_IMAGE)			!  USER_HAS_PRIV to
	ITMLST(24) = %LOC(THIS_IMAGE_LEN)		!  fetch the full image
							!  name of this program
	IF (USER_HAS_PRIV('SYSPRV')) THEN

	    CALL TERMINAL_DATA

	    SYSTEM = DEVTYPE .GE. DT$_VT100 .AND. DEVTYPE .LE. DT$_VT132

	ENDIF

	END
	SUBROUTINE INITIALIZE

	IMPLICIT INTEGER (A-Z)

	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	CHARACTER*37 HEADING
	LOGICAL FIRST_CALL / .TRUE. /

	EXTERNAL CONTROL__Y

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	DATA HEADING /
	1 'Port	Pid	Username	Uic	Process		 Image' /

	IF (SYSTEM) THEN

	    CALL LIB$ERASE_PAGE(1,1)

	    CALL LIB$PUT_LINE(HEADING)

	    IF (.NOT.FIRST_CALL) RETURN

	    FIRST_CALL=.FALSE.

	    CALL CONTROL_Y(CONTROL__Y)

	    CALL SET_INPUT_ALARM

	    CALL LIB$PUT_SCREEN(' Type H for help. ',24,4,3)

	ELSE

	    OPEN (1,FILE='SYS$OUTPUT:',STATUS='NEW')

	    WRITE (1,1000) HEADING

	ENDIF

	CALL SETLIST

1000	FORMAT ('0',A/)

	END
	SUBROUTINE SETLIST

	IMPLICIT INTEGER (A-Z)

	PARAMETER ( JPI$_IMAGNAME = '207'X )
	PARAMETER ( JPI$_PID      = '319'X )
	PARAMETER ( JPI$_PRCNAM   = '31C'X )
	PARAMETER ( JPI$_TERMINAL = '31D'X )
	PARAMETER ( JPI$_UIC      = '304'X )
	PARAMETER ( JPI$_USERNAME = '202'X )
	PARAMETER ( JPI$_STS      = '305'X )

	CHARACTER IMAG*128,PROC*16,PORT*4,USER*12

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /DATALEN/  IMAGLEN,PROCLEN,PORTLEN,USERLEN
	COMMON /ITEMLIST/ ITMLST(22)

	DATA ITMLST / 22*0 /

	ITMLST(1)  = IOR(ISHFT(JPI$_IMAGNAME,16),128)
	ITMLST(4)  = IOR(ISHFT(JPI$_PID     ,16),  4)
	ITMLST(7)  = IOR(ISHFT(JPI$_PRCNAM  ,16), 15)
	ITMLST(10) = IOR(ISHFT(JPI$_TERMINAL,16),  4)
	ITMLST(13) = IOR(ISHFT(JPI$_UIC     ,16),  4)
	ITMLST(16) = IOR(ISHFT(JPI$_USERNAME,16), 12)
	ITMLST(19) = IOR(ISHFT(JPI$_STS     ,16),  4)

	ITMLST(2)  = %LOC(IMAG)
	ITMLST(5)  = %LOC(PID)
	ITMLST(8)  = %LOC(PROC)
	ITMLST(11) = %LOC(PORT)
	ITMLST(14) = %LOC(UIC)
	ITMLST(17) = %LOC(USER)
	ITMLST(20) = %LOC(STS)

	ITMLST(3)  = %LOC(IMAGLEN)
	ITMLST(9)  = %LOC(PROCLEN)
	ITMLST(12) = %LOC(PORTLEN)
	ITMLST(18) = %LOC(USERLEN)

	END
	SUBROUTINE GET_DATA(PIDADR,*)

	IMPLICIT INTEGER (A-Z)

	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128
	EXTERNAL SS$_SUSPENDED,SS$_NOMOREPROC

	INTEGER*2 IOSB(4)

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /DATALEN/  IMAGLEN,PROCLEN,PORTLEN,USERLEN
	COMMON /ITEMLIST/ ITMLST(22)

10	STATUS=SYS$GETJPI(%VAL(2),PIDADR,,ITMLST,IOSB,,)

	IF (STATUS.EQ.%LOC(SS$_SUSPENDED)) GO TO 10

	IF (STATUS.EQ.%LOC(SS$_NOMOREPROC)) RETURN 1

	IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

	STATUS=SYS$WAITFR(%VAL(2))

	IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

	IF (.NOT.IOSB(1)) CALL LIB$STOP(%VAL(IOSB(1)))

	IF (PORTLEN.NE.0) RETURN		! RETURN IF INTERACTIVE PROCESS

	IF (IAND(STS,'00004000'X).EQ.0) GO TO 10    ! LOOP IF NOT BATCH PROCESS

	PORT(1:1)=CHAR(127)			    ! FOR BATCH PROCESSES, WE
	PORT(2:2)=CHAR(IAND(PID/'10000'X,'FF'X))    !  BUILD A DUMMY PORT NAME
	PORT(3:3)=CHAR(IAND(PID/'100'X,'FF'X))	    !  FROM THE PID.  IT WILL
	PORT(4:4)=CHAR(IAND(PID,'FF'X))		    !  LEXICOGRAPHICALLY COME
						    !  AFTER ALL REAL PORTS.
	END
	SUBROUTINE WAIT

	IMPLICIT INTEGER (A-Z)

	CHARACTER NOW*10 / ' ' /
	INTEGER*4 DAYTIME(2)
	LOGICAL*1 INPUT_READY
	LOGICAL SYSTEM,CHANGE,START,END,BEGIN
	CHARACTER*1 INPUT_CHAR,INPUT_FLAG
	EXTERNAL GO_WAKE_UP

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC
	COMMON /TTIN_/ INPUT_CHAR,INPUT_FLAG,INPUT_READY

	DATA DAYTIME,CYCLES / 2*'FFFFFFFF'X,0 /

	IF (BEGIN) THEN				! Delete the 'Type H for help'
	    CYCLES=CYCLES+1			!  message after about 10 sec-
	    IF (CYCLES.EQ.4) THEN		!  onds, if it is still there.
		BEGIN = .FALSE.			!  (It is also deleted when any
		CALL LIB$ERASE_LINE(24,1)	!  character is typed in.)
	    ENDIF
	ENDIF

	CALL TIME(NOW(2:))

	CALL LIB$PUT_SCREEN(NOW,1,71,2)

	CALL LIB$SET_SCROLL(20,24)

	CALL LIB$SET_CURSOR(24,1)

	IF (.NOT.INPUT_READY) THEN

	    DAYTIME(1)=-WAITSEC*10000000

	    STATUS=SYS$SETIMR(,DAYTIME,GO_WAKE_UP,)

	    IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

	    CALL GO_HIBERNATE

	    IF (INPUT_READY) THEN

		STATUS=SYS$CANTIM(,,)

		IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

		CALL PROCESS_INPUT

	    ENDIF

	ELSE

	    CALL PROCESS_INPUT

	ENDIF

	END
	SUBROUTINE PROCESS_INPUT

	IMPLICIT INTEGER (A-Z)

	LOGICAL HELPED
	LOGICAL SYSTEM,CHANGE,START,END,BEGIN
	LOGICAL*1 INPUT_READY
	CHARACTER*1 INPUT_CHAR,INPUT_FLAG

	COMMON /TTIN_/ INPUT_CHAR,INPUT_FLAG,INPUT_READY
	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	DATA WAITSEC / 3 /

	IF (BEGIN) THEN			! Delete the 'Type H for help' message
	    BEGIN = .FALSE.		!  if it is still there.  (It is also
	    CALL LIB$ERASE_LINE(24,1)	!  deleted at 10 seconds into the prog-
	ENDIF				!  ram.)

	HELPED = .FALSE.

10	IF (INPUT_FLAG.EQ.' ') THEN

	    CALL STR$UPCASE(INPUT_CHAR,INPUT_CHAR)

	    IF (INPUT_CHAR.EQ.'E'.OR.INPUT_CHAR.EQ.'Q') THEN

		CALL CONTROL__Y					! EXIT, QUIT
		RETURN

	    ELSE IF (INPUT_CHAR.EQ.'U') THEN

		CHANGE = .TRUE.
		RETURN

	    ELSE IF (INPUT_CHAR.GE.'3'.AND.INPUT_CHAR.LE.'9') THEN

		WAITSEC=ICHAR(INPUT_CHAR)-ICHAR('0')
		IF (HELPED) CALL REPAINT
		GO TO 20

	    ELSE IF (INPUT_CHAR.EQ.'H') THEN

		CALL HELP
		HELPED = .TRUE.
		GO TO 10

	    ELSE IF (INPUT_CHAR.EQ.' ') THEN

		IF (.NOT.HELPED) GO TO 20

	    ENDIF

	ELSE IF (INPUT_FLAG.EQ.'*') THEN

	    IF (INPUT_CHAR.EQ.CHAR(21)) THEN

		CHANGE = .TRUE.
		RETURN

	    ELSE IF (INPUT_CHAR.EQ.CHAR(0)) THEN

		RETURN

	    ENDIF

	ELSE

	    IF (INPUT_CHAR.EQ.'A') THEN

		IF (HELPED) CALL REPAINT
		CALL SCROLL(+1,1)
		GO TO 20

	    ELSE IF (INPUT_CHAR.EQ.'B') THEN

		IF (HELPED) CALL REPAINT
		CALL SCROLL(-1,1)
		GO TO 20

	    ENDIF

	ENDIF

	CALL REPAINT

20	CALL SET_INPUT_ALARM

	END
	SUBROUTINE CONTROL__Y

	IMPLICIT INTEGER (A-Z)

	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	END=.TRUE.

	CALL LIB$ENABLE_CTRL('02000000'X)

	CALL GO_WAKE_UP

	END
	SUBROUTINE SCROLL(BIAS,TYPE)

*	IF TYPE=1, UPDATE DISPLAY
*	IF TYPE=0, DO NOT UPDATE

	IMPLICIT INTEGER (A-Z)

	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	IF (BIAS.EQ.+1.AND.LINE_NO(1).EQ. 2) RETURN
	IF (BIAS.EQ.-1.AND.MAXL      .LE.22) RETURN

	THIS=1

	DO WHILE (THIS.NE.0)

	    LINE_NO(THIS)=LINE_NO(THIS)+BIAS

	    IF (LINE_NO(THIS).EQ.3) TOPLINE=THIS

	    CALL LIST_SCAN

	ENDDO

	MAXL=MAXL+BIAS

	IF (TYPE.EQ.0) RETURN

	CALL MORE_FLAG

	IF (BIAS.EQ.-1) THEN

	    CALL UP_SCROLL(3)

	ELSE

	    THIS=TOPLINE

	    CALL DOWN_SCROLL(3)

	ENDIF

	END
	SUBROUTINE UP_SCROLL(TOPLINE)

	IMPLICIT INTEGER (A-Z)

	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	CALL LIB$SET_SCROLL(TOPLINE,22)
	CALL LIB$SET_CURSOR(22,1)
	CALL LIB$UP_SCROLL()
	CALL LIB$SET_SCROLL(1,24)

	THIS=1		      ! See if there is anything at the bottom to print

	DO WHILE (THIS.NE.0)

	    IF (LINE_NO(THIS).EQ.22) THEN

		CALL PRINT_LINE
		RETURN

	    ENDIF

	    CALL LIST_SCAN

	ENDDO
	
	RETURN



	ENTRY ALT_SCROLL(BOTLINE)


	CALL LIB$SET_SCROLL(3,BOTLINE)
	CALL LIB$SET_CURSOR(3,1)
	CALL LIB$DOWN_SCROLL()
	CALL LIB$SET_SCROLL(1,24)

	THIS=1		      ! See if there is anything at the top to print
			      !  (there always will be)
	DO WHILE (THIS.NE.0)

	    LINE_NO(THIS)=LINE_NO(THIS)+1

	    IF (LINE_NO(THIS).EQ.3) CALL PRINT_LINE

	    CALL LIST_SCAN

	ENDDO

	RETURN



	ENTRY DOWN_SCROLL(TOPLINE)


	CALL LIB$SET_SCROLL(TOPLINE,22)
	CALL LIB$SET_CURSOR(TOPLINE,1)
	CALL LIB$DOWN_SCROLL()
	CALL LIB$SET_SCROLL(1,24)

	CALL PRINT_LINE

	END
	SUBROUTINE REPAINT

	IMPLICIT INTEGER (A-Z)

	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	CALL INITIALIZE

	THIS=1

10	CALL LIST_SCAN

	IF (THIS.EQ.0) GO TO 20

	CALL PRINT_LINE

	GO TO 10

20	CALL MORE_FLAG

	END
	SUBROUTINE MORE_FLAG

	IMPLICIT INTEGER (A-Z)

	CHARACTER*10 MORE
	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO

	MORE = ' '

	IF (MAXL.GT.22)      MORE(4:10) =    'MORE v '

	IF (LINE_NO(1).LT.2) MORE(1:7)  = ' ^ MORE'

	IF (MORE.NE.' ') THEN

	    CALL LIB$PUT_SCREEN(MORE,24,35,2)

	ELSE

	    CALL LIB$ERASE_LINE(24,2)

	ENDIF

	END
	SUBROUTINE PRINT_LINE

	IMPLICIT INTEGER (A-Z)

	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128
	CHARACTER LINE*80
	CHARACTER*63 DATA,LIST(1)
	INTEGER LINE_NO(1)

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_1/ LIST
	COMMON /LIST_3/ FREE,THIS,LAST,NEW
	COMMON /LINE_/ LINE,LINELEN

	EQUIVALENCE (DATA,PORT)

	IF (THIS.LE.2) RETURN				! BLANK BEFORE BATCHES

	LINENO=LINE_NO(THIS)

	IF (LINENO.LT.3.OR.LINENO.GT.22) RETURN		! SCREEN OVERFLOW TEST

	DATA=LIST(THIS)

	CALL FORMAT

	CALL LIB$PUT_SCREEN(LINE(1:LINELEN),LINENO,1)

	IF (LINELEN.LT.80) CALL LIB$ERASE_LINE

	END
	SUBROUTINE FORMAT

	IMPLICIT INTEGER (A-Z)

	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128
	CHARACTER LINE*80,IMAGE*23
	INTEGER*2 UICC(2)

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /LINE_/ LINE,LINELEN

	EQUIVALENCE (IMAG,IMAGE),(UIC,UICC)

	LINE(1:6)=PORT
	CALL OTS$CVT_L_TZ(PID,LINE(7:14),%VAL(8))
	LINE(15:30)='  '//USER//' ['
	CALL OTS$CVT_L_TO(UICC(2),LINE(31:33),%VAL(3),%VAL(2))
	LINE(34:34)=','
	CALL OTS$CVT_L_TO(UICC(1),LINE(35:37),%VAL(3),%VAL(2))
	LINE(38:57)=']  '//PROC
	LINE(58:80)=IMAGE

C	The above code performs:
C
C	WRITE (LINE,1000) PORT,PID,USER,UIC/'10000'X,
C	1				MOD(UIC,'10000'X),PROC,IMAGE
C 1000	FORMAT (A,2X,Z8.8,2X,A,1X,'[',O3.3,',',O3.3,']',2X,A,1X,A)

	IF (PORT(1:1).GT.'Z') LINE(1:4) = '    '	! FIX BATCH DUMMY PORT

	CALL STR$TRIM(LINE,LINE,LINELEN)

	END
	SUBROUTINE PRINT_IMAGE(IMAGE)

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) IMAGE
	CHARACTER*63 LIST
	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_1/ LIST
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	LINENO=LINE_NO(THIS)

	IF (LINENO.LT.3.OR.LINENO.GT.22) RETURN		! SCREEN OVERFLOW TEST

	IF (IMAGE.NE.' ') THEN

	    CALL STR$TRIM(IMAGE,IMAGE,LEN)

	    IF (LEN.LT.20) THEN

		IMAGE(LEN+1:) = CHAR(27) // '[K'

		LEN=LEN+3

	    ENDIF

	    CALL LIB$PUT_SCREEN(IMAGE(1:LEN),LINENO,58)

	ELSE

	    CALL LIB$ERASE_LINE(LINENO,58)

	ENDIF

	END
	SUBROUTINE ADD_PORT

	IMPLICIT INTEGER (A-Z)

	CHARACTER*63 LIST(1)
	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_1/ LIST
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	L=LINE_NO(LAST)+1

	LINE_NO(THIS)=L-1

	T=THIS

	DO WHILE (THIS.NE.0)

	    LINE_NO(THIS)=LINE_NO(THIS)+1

	    CALL LIST_SCAN

	ENDDO

	MAXL=LINE_NO(LAST)
	THIS=T

	IF (L.LT.3) THEN

	    CALL SCROLL(-1,0)

	ELSE IF (L.LE.22) THEN

	    CALL DOWN_SCROLL(L)

	ENDIF

	CALL RING_BELL(1)

	TOTAL=TOTAL+1

	IF (MAXL.GT.22) CALL MORE_FLAG

	END
	SUBROUTINE DELETE_PORT

	IMPLICIT INTEGER (A-Z)

	INTEGER LINE_NO(1)

	COMMON /USERDATA/ MAXL,TOTAL,LINE_NO
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	L=LINE_NO(THIS)

	CALL LIST_DELETE

	DO WHILE (THIS.NE.0)

	    LINE_NO(THIS)=LINE_NO(THIS)-1

	    CALL LIST_SCAN

	ENDDO

	MAXL=LINE_NO(LAST)

	IF (L.LT.3) THEN

	    CALL SCROLL(+1,0)		! This line was not on the screen.

	ELSE IF (L.LE.22) THEN		! If line was on screen, delete it and
					!  add another, if any (add a line from
	    IF (LINE_NO(1).LT.2) THEN	!  the top if any; if none, try the
					!  bottom.
		CALL ALT_SCROLL(L)

	    ELSE

		CALL UP_SCROLL(L)

	    ENDIF

	ENDIF

	CALL RING_BELL(1)			! RING BELL FOR THE DEPARTED

	TOTAL=TOTAL-1

	IF (TOTAL.EQ.1) CALL RING_BELL(7)	! NO ONE ELSE ON BUT US

	CALL MORE_FLAG

	END
	SUBROUTINE RING_BELL(COUNT)

	IMPLICIT INTEGER (A-Z)

	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC

	CHARACTER*1 BELL / 7 /

	IF (START) RETURN		! KEEP QUIET WHEN FIRST STARTING UP

	DO I=1,COUNT

	    CALL LIB$PUT_LINE(BELL,0)

	ENDDO

	END
	SUBROUTINE DISPLAY2

*
*	NOTE THAT THE CALLING PROCEDURE MUST HAVE THE DCL SYMBOL
*
*		USERS_COMMAND_EDIT
*
*	DEFINED TO BE A VALID DCL STATEMENT TO CALL EDT /READONLY
*
*	ON A FILE USERLIST.DAT (or some such name).  IN ORDER TO
*
*	CORRESPOND TO THE HELP TEXT (which says to hit PAGE to
*
*	perform a QUIT from EDT) YOU MUST CALL IN AN EDTINI COMMAND
*
*	FILE CONTAINING:
*
*		Set Mode Change
*		Define Key 7 as "Ext Quit."
*
*
*	For example:
*
*	   $ USERS_COMMAND_EDIT == -
*		"EDIT/READ SYS$MANAGER:USERLIST.DAT /COMMAND=..."
*

	IMPLICIT INTEGER (A-Z)

	CALL LIB$PUT_SCREEN(' Please wait for EDT to begin ',24,1,3)

	STATUS=LIB$SPAWN('USERS_COMMAND_EDIT')

	IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))

	CALL SET_INPUT_ALARM

	END
	SUBROUTINE GET_IMAGE(IMAGE)

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) IMAGE
	CHARACTER*128 THIS_IMAGE
	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /DATALEN/  IMAGLEN,PROCLEN,PORTLEN,USERLEN
	COMMON /THIS/ THIS_IMAGE,THIS_IMAGE_LEN

	IF (IMAGLEN.EQ.THIS_IMAGE_LEN .AND.
	1	IMAG(1:IMAGLEN).EQ.THIS_IMAGE(1:IMAGLEN)) THEN

	    IMAGE = 'users'
	    RETURN

	ENDIF

	IF (IMAG(1:4).EQ.'SYS$') IMAG=IMAG(INDEX(IMAG,':')+1:)

	COL1=INDEX(IMAG(1:IMAGLEN),']')+1
	COL2=INDEX(IMAG(COL1:IMAGLEN),'.')+COL1-2
	COL1=MAX(1,COL2-22)

	IMAGE=IMAG(COL1:COL2)

	IF (IMAGE(1:8).EQ.'[SYSEXE]') THEN

	    IMAGE=IMAGE(9:)

	    CALL TRANSLATE_TO_LC(IMAGE)		! TRANSLATE TO LOWER CASE

	ENDIF

	END
	SUBROUTINE TRANSLATE_TO_LC(STRING)

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) STRING

	DO C=1,LEN(STRING)

	    IF (STRING(C:C).GE.'A'.AND.STRING(C:C).LE.'Z')
	1		STRING(C:C)=CHAR(ICHAR(STRING(C:C))+'40'O)

	ENDDO

	END
	SUBROUTINE LIST_INIT(LISTSIZE)

*	INITIALIZES LINKED LIST STRUCTURE OF PROCESS LIST.
*	ARRAYS 'LIST' AND 'LINK' MUST BE DECLARED OF SIZE 'LISTSIZE'
*	SOMEWHERE IN THE PROGRAM.

	IMPLICIT INTEGER (A-Z)

	CHARACTER*1 NUL /   0 /
	CHARACTER*1 DEL / 127 /

	CHARACTER*63 LIST(1)
	INTEGER*2 LINK(1)

	COMMON /LIST_1/ LIST
	COMMON /LIST_2/ LINK
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	FREE=3

	LINK(1) = 2					! HEAD OF PROCESS LIST

	LIST(2) = DEL // NUL // NUL // NUL // ' '	! BLANK ENTRY FOR START
	LINK(2) = 0					!  OF BATCH JOB SECTION

	DO I=FREE,LISTSIZE-1				! INITALIZE FREE LIST

	    LINK(I) = I + 1

	ENDDO

	LINK(LISTSIZE)=0				! END OF FREE LIST

	END
	SUBROUTINE LIST_LOOK_UP(DATA)

*	FIND AN ENTRY IN THE PROCESS LIST, OR IF NOT IN LIST ENTER
*	IT.  FIRST 4 CHARACTERS IN 'DATA' ARE CHECKED AGAINST FIRST
*	4 CHARACTERS IN EACH ENTRY (THIS IS THE PORT).  ENTRIES ARE
*	MADE IN LEXICOGRAPHICAL ORDER BY PORT.  'NEW' IS TRUE IF WE
*	MADE A NEW ENTRY.  'THIS' POINTS TO THE ENTRY, 'LAST' TO ITS
*	PREDECESSOR.  USER MUST HAVE CALLED 'LIST_INIT' TO INITIALIZE
*	THE LIST.

	IMPLICIT INTEGER (A-Z)

	CHARACTER*(*) DATA
	LOGICAL NEW

	CHARACTER*63 LIST(1)
	INTEGER*2 LINK(1)
	LOGICAL SYSTEM,CHANGE,START,END,BEGIN

	EXTERNAL USERS_LISTFULL		! From USERSERR.MSG message module

	COMMON /DISPLAY/ SYSTEM,CHANGE,START,END,BEGIN,WAITSEC
	COMMON /LIST_1/ LIST
	COMMON /LIST_2/ LINK
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	LAST=1
	THIS=LINK(1)

10	IF (THIS.EQ.0) THEN

20	    IF (FREE.EQ.0) THEN

		IF (SYSTEM) CALL LIB$ERASE_PAGE(1,1)

		CALL LIB$STOP(USERS_LISTFULL)

	    ENDIF

	    NEWL=FREE
	    FREE=LINK(FREE)

	    LINK(LAST)=NEWL
	    LIST(NEWL)=DATA
	    LINK(NEWL)=THIS

	    THIS=NEWL
	    NEW=.TRUE.
	    RETURN

	ELSE IF (LIST(THIS)(1:4).EQ.DATA(1:4)) THEN

	    NEW=.FALSE.
	    RETURN

	ELSE IF (LIST(THIS)(1:4).LT.DATA(1:4)) THEN

	    LAST=THIS
	    THIS=LINK(THIS)
	    GO TO 10

	ELSE   ! LIST(THIS)(1:4).GT.DATA(1:4)) THEN

	    GO TO 20

	ENDIF

	END	    
	SUBROUTINE LIST_DELETE

*	DELETE ENTRY FROM PROCESS LIST.  'THIS' MUST POINT TO ENTRY
*	BEING DELETED, 'LAST' TO ITS PREDECESSOR.

	IMPLICIT INTEGER (A-Z)

	INTEGER*2 LINK(1)

	COMMON /LIST_2/ LINK
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	LINK(LAST)=LINK(THIS)

	LINK(THIS)=FREE

	FREE=THIS

	THIS=LINK(LAST)

	END
	SUBROUTINE LIST_SCAN

*	TRAVERSE TO NEXT GOOD ENTRY IN PROCESS LIST.  CALLER MUST
*	SET THIS=1 BEFORE FIRST CALL.  IF THIS=0 AFTER CALL, THE
*	END OF THE LIST WAS HIT.

	IMPLICIT INTEGER (A-Z)

	INTEGER*2 LINK(1)

	COMMON /LIST_2/ LINK
	COMMON /LIST_3/ FREE,THIS,LAST,NEW

	LAST=THIS

	THIS=LINK(LAST)

	END
	SUBROUTINE HELP

	IMPLICIT INTEGER (A-Z)

	CHARACTER*1 INPUT_CHAR,INPUT_FLAG
	LOGICAL*1 INPUT_READY

	COMMON /TTIN_/ INPUT_CHAR,INPUT_FLAG,INPUT_READY

	CALL LIB$ERASE_PAGE(1,1)

	CALL LIB$PUT_LINE(' ',2)

	CALL LIB$PUT_LINE
	1	('			    The USERS command    ',3,3)

	CALL LIB$PUT_LINE
	1		('  Type Ctrl/Y or E or Q to quit.        ' //
	2				'Type Ctrl/W to refresh screen.',2)

	CALL LIB$PUT_LINE
	1		('  Type an integer n, from 3 to 9, to ' //
	2			'set update interval to n seconds.',2)

	CALL LIB$PUT_LINE
	1		('  Type an up-arrow or down-arrow to see ' //
	2			'other users if screen is full.',2)

	CALL LIB$PUT_LINE
	1		('  Type Ctrl/U or U to examine list of users;'
	2				// ' hit PAGE key to quit EDT.',2)

	CALL LIB$PUT_LINE
	1		('  Type H to re-display this help information.',2)

	CALL LIB$PUT_SCREEN('Type any character to continue ',24,1)

	CALL SET_INPUT_ALARM

	IF (.NOT.INPUT_READY) CALL GO_HIBERNATE

	END
	SUBROUTINE SIMPLE_DISPLAY

	IMPLICIT INTEGER (A-Z)

	CHARACTER PORT*4,USER*12,PROC*16,IMAG*128
	CHARACTER LINE*80
	CHARACTER*63 DATA,LIST(1)

	COMMON /DATALIST/ PORT,PID,USER,UIC,PROC,IMAG,STS
	COMMON /LIST_1/ LIST
	COMMON /LIST_3/ FREE,THIS,LAST,NEW
	COMMON /LINE_/ LINE,LINELEN

	EQUIVALENCE (DATA,PORT)

	THIS=1

10	CALL LIST_SCAN

	IF (THIS.LE.2) THEN

	    IF (THIS.EQ.0) GO TO 20

	    WRITE (1,1000)

	    GO TO 10

	ENDIF

	DATA=LIST(THIS)

	CALL FORMAT

	WRITE (1,1000) LINE(1:LINELEN)

	GO TO 10

20	WRITE (1,1000)

	CALL EXIT

1000	FORMAT (' ',A)

	END
