C
C	Include file for use with VAXNET program.
C
C******************************************************************************
C	When you add a symbol, make sure you make an entry in one of the
C	COMMONs below or else the symbol is defined locally not globally.
C******************************************************************************
C
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*2 LIOSB(4), RIOSB(4), XIOSB(4), XLIOSB(4), XRIOSB(4),
	1		TYPEAHEAD_COUNT(4), LTYPEAHEAD_COUNT(4)

	INTEGER*4 LDESC(2), RDESC(2), XDESC(2), EXIT_STATUS

	INTEGER*4 BYTE_COUNT, RECORD_COUNT, RBYTE_COUNT, LBYTE_COUNT,
	1	TIMEOUTS, PARITY_ERRORS, NAKS_RECEIVED, NAKS_XMITTED,
	1	ENQS_RECEIVED, ENQS_XMITTED, TIMEOUT_COUNT, SYMBOL_COUNT,
	1	LOCAL_STATUS, REMOTE_STATUS, FUNCTION, TERMINATOR,
	1	FLOW, MODE, RINDEX, LCHAN_IN, LCHAN_OUT, RCHAN_IN, RCHAN_OUT
	1	LOCAL_ASTS, REMOTE_ASTS, LEFN_IN, LEFN_OUT, REFN_IN, REFN_OUT,
	1	MCHAN_IN, MCHAN_OUT, MEFN_IN, MEFN_OUT

	INTEGER*4 BAUD_RATE, LOCAL_SIZE, REMOTE_SIZE, SPEED_SIZE, SYSTEM_SIZE,
	1	LOGFILE_SIZE, INFILE_SIZE, OUTFILE_SIZE, PHONE_SIZE,
	1	CMD_SIZE, MODEM_SIZE, LOGIN_SIZE, USER_SIZE, PASSWORD_SIZE,
	1	LOGOUT_SIZE, TYPEAHEAD_SIZE, AUTODIAL_TYPE, MAX_TYPEAHEAD,
	1	LMAX_TYPEAHEAD, MAX_RECSIZE, RSIZE, VSIZE

	INTEGER*4 REMOTE_CHAR(3), LOCAL_CHAR(3)
	INTEGER*4 TERMPTR(2), TERMTBL(8), NOTERM(2), TPTR(2), TTBL(8)
	DATA TERMTBL /0,0,0,0,0,0,0,0/	! Read terminator table (remote).
	DATA TTBL    /0,0,0,0,0,0,0,0/	! Long terminator table (modem).
	DATA NOTERM  /0,0/		! Don't terminate on anything.
C
C	Parameters.
C
	CHARACTER*(*) SS, DS, NULL, BELL
	PARAMETER (SS = CHAR(13)//CHAR(10)) ! Single space.
	PARAMETER (DS = SS//SS)		! Double space.
	PARAMETER (BELL = CHAR(7))	! Bell.
	PARAMETER (NULL = CHAR(0))	! NULL.
	PARAMETER SOH = 1		! Start of header.		CTRL/A
	PARAMETER STX = 2		! Start of text.		CTRL/B
	PARAMETER ETX = 3		! End of text.			CTRL/C
	PARAMETER EOT = 4		! End of transmission.		CTRL/D
	PARAMETER ENQ = 5		! Enquire.			CTRL/E
	PARAMETER ACK = 6		! Acknowlegment.		CTRL/F
	PARAMETER LF  = 10		! Line feed.			CTRL/J
	PARAMETER CR  = 13		! Carriage return.		CTRL/M
	PARAMETER DLE = 16		! Data link escape.		CTRL/P
	PARAMETER NAK = 21		! Negative Acknowlegment.	CTRL/U
	PARAMETER SYN = 22		! Synchronize byte.		CTRL/V
	PARAMETER ETB = 23		! End of transmission block.	CTRL/W
	PARAMETER CAN = 24		! Cancel transmission.		CTRL/X
	PARAMETER EOF = 26		! End of file.			CTRL/Z
	PARAMETER FILE_UNIT = 1		! Unit # for VAX file.
	PARAMETER LOG_UNIT = 2		! Unit # for log file.
	PARAMETER CMD_UNIT = 3		! Unit # for command file.
	PARAMETER IN_UNIT = 5		! Unit for batch SYS$COMMAND.
	PARAMETER OUT_UNIT = 6		! Unit for batch SYS$OUTPUT.
	PARAMETER ESCAPE = 27		! Escape.
	PARAMETER IN_SIZE = 80		! Size of SYS$COMMAND records.
	PARAMETER OUT_SIZE = 512	! Size of SYS$OUTPUT records.
	PARAMETER READ_SIZE = 512	! Size of remote reads.
	PARAMETER LOGBUF_SIZE = 512	! Log file buffer size.
	PARAMETER BUFFER_SIZE = 1024	! Buffer size.
	PARAMETER RETRY_LIMIT = 8	! # of retries during transmission.
	PARAMETER AUTODIAL_LIMIT = 3	! # of times to retry autodial.
	PARAMETER AUTODIAL_TIMEOUT = 59	! Autodial timeout limit.
	LOGICAL*1 INTERRUPT_CHAR(1)	! Interrupt character.
	LOGICAL*1 TERMINATE_CHAR(1)	! Terminating character for dump.
	LOGICAL*1 RBUFFER(BUFFER_SIZE)	! Receive buffer.
	LOGICAL*1 XBUFFER(BUFFER_SIZE)	! Transmit buffer.
	LOGICAL*1 TBUFFER(BUFFER_SIZE)	! Logfile buffer.
	LOGICAL*1 LBUFFER(BUFFER_SIZE)	! Local buffer.
C
C	Flags.
C
	LOGICAL	CONTROLC_TYPED, IN_A_COMMAND, LOGFILE, BACKUP,
	1	RECEIVER_BUSY, XMITTER_BUSY, READ_ONE, LOCAL_ECHO,
	1	DEBUG_MODE, REMOTE, HANGUP, DUMP_MODE, NEED_TO_DEAL,
	1	NEED_TO_DEAS, EXIT_ON_ERROR, CROSS_FILE, INI_FILE,
	1	AUTODIAL, MODEM, WILDCARD, LOG_LOCAL, STARTUP,
	1	BATCH_MODE, CMD_MODE, WANTS_HELP, HIBERNATING,
	1	INTERRUPT_TYPED, ECHO_DUMP, EXITING, AUTO_MODE,
	1	MODEM_ONLINE
C
C	Direction for GET/SEND.
C
	PARAMETER IN = 1		! Get a file from the remote.
	PARAMETER OUT = 2		! Send a file to the remote.
C
C	Type of autodial modem.
C
	PARAMETER DF03 = 1		! DEC DF03 modem.
	PARAMETER RIXON = 2		! RIXON R212 modem.
	PARAMETER MABELL = 3		! BELL ???? modem.
C
C	Character strings for filenames, system type, baud rate, etc.
C
	CHARACTER*128 VAX_FILE, REMOTE_FILE, CMD_FILE, LOG_FILE
	CHARACTER*10 SYSTEM_TYPE, REMOTE_BAUD, MODEM_TYPE, TERMINAL_TYPE
	CHARACTER*80 LOCAL_DEVICE, REMOTE_DEVICE, LOGIN_CMD, LOGOUT_CMD
	CHARACTER*80 PHONE_NUMBER, USER_NAME, PASSWORD

	COMMON /BUFFERS/ RBUFFER, XBUFFER, LBUFFER, TBUFFER, VAX_FILE,
	1 	REMOTE_FILE, SYSTEM_TYPE, REMOTE_BAUD, LOCAL_DEVICE,
	1	REMOTE_DEVICE, INTERRUPT_CHAR, PHONE_NUMBER, MODEM_TYPE,
	1	CMD_FILE, LOG_FILE, LOGIN_CMD, LOGOUT_CMD, USER_NAME, PASSWORD,
	1	TERMINATE_CHAR, MODE, RINDEX, FLOW, BAUD_RATE, TERMINAL_TYPE

	COMMON /CHANNELS/ LCHAN_IN, LCHAN_OUT, RCHAN_IN, RCHAN_OUT,
	1	LEFN_IN, LEFN_OUT, REFN_IN, REFN_OUT, MCHAN_IN, MCHAN_OUT,
	1	MEFN_IN, MEFN_OUT

	COMMON /COUNTS/ BYTE_COUNT, RECORD_COUNT, RBYTE_COUNT, LBYTE_COUNT,
	1	TIMEOUTS, PARITY_ERRORS, NAKS_RECEIVED, NAKS_XMITTED,
	1	ENQS_RECEIVED, ENQS_XMITTED, TIMEOUT_COUNT, AUTODIAL_TYPE,
	1	MAX_TYPEAHEAD, MAX_RECSIZE, TYPEAHEAD_COUNT, LTYPEAHEAD_COUNT,
	1	SYMBOL_COUNT, LOCAL_ASTS, REMOTE_ASTS, LMAX_TYPEAHEAD

	COMMON /FLAGS/ RECEIVER_BUSY, XMITTER_BUSY,
	1	BACKUP, READ_ONE, LOCAL_ECHO, DEBUG_MODE, HANGUP, REMOTE,
	1	CONTROLC_TYPED, IN_A_COMMAND, LOGFILE, DUMP_MODE,
	1	NEED_TO_DEAL, NEED_TO_DEAS, EXIT_ON_ERROR, CROSS_FILE,
	1	INI_FILE, MODEM, AUTODIAL, WILDCARD, LOG_LOCAL, STARTUP,
	1	BATCH_MODE, CMD_MODE, WANTS_HELP, HIBERNATING, INTERRUPT_TYPED,
	1	ECHO_DUMP, EXITING, AUTO_MODE, MODEM_ONLINE

	COMMON /SIZES/ LOCAL_SIZE, REMOTE_SIZE, SPEED_SIZE, SYSTEM_SIZE,
	1	LOGFILE_SIZE, INFILE_SIZE, OUTFILE_SIZE, PHONE_SIZE,
	1	CMD_SIZE, MODEM_SIZE, USER_SIZE, PASSWORD_SIZE,
	1	LOGIN_SIZE, LOGOUT_SIZE, TYPEAHEAD_SIZE, RSIZE, VSIZE

	COMMON /STATUS/ LOCAL_STATUS, REMOTE_STATUS, EXIT_STATUS, LIOSB,
	1	RIOSB, XIOSB, XLIOSB, XRIOSB, FUNCTION, LOCAL_CHAR,
	1	REMOTE_CHAR, TERMPTR, TERMTBL, NOTERM, TERMINATOR, TPTR,
	1	TTBL, LDESC, RDESC, XDESC
C
C	Define the I/O functions.
C
	PARAMETER (IO$_READLBLK   =	'00000021'X)
	PARAMETER (IO$_READPROMPT =	'00000037'X)
	PARAMETER (IO$_SETMODE    =	'00000023'X)
	PARAMETER (IO$_SENSEMODE  =	'00000027'X)
	PARAMETER (IO$_TTYREADALL =	'0000003A'X)
	PARAMETER (IO$_WRITELBLK  =	'00000020'X)
	PARAMETER (IO$M_CTRLCAST  =	'00000100'X)
	PARAMETER (IO$M_CVTLOW    =	'00000100'X)
	PARAMETER (IO$M_HANGUP	  =	'00000200'X)
	PARAMETER (IO$M_NOECHO    =	'00000040'X)
	PARAMETER (IO$M_NOFORMAT  =	'00000100'X)
	PARAMETER (IO$M_TYPEAHDCNT=	'00000040'X)
	PARAMETER (IO$M_PURGE     =	'00000800'X)
	PARAMETER (IO$M_TIMED     =	'00000080'X)
C
C	Define the status return codes.
C
	PARAMETER (SS$_ABORT	  =	'0000002C'X)
	PARAMETER (SS$_CONTROLC	  =	'00000651'X)
	PARAMETER (SS$_CONTROLY	  =	'00000611'X)
	PARAMETER (SS$_DATAOVERUN =	'00000838'X)
	PARAMETER (SS$_DEVALRALLOC=	'00000641'X)
	PARAMETER (SS$_EXQUOTA	  =	'0000001C'X)
	PARAMETER (SS$_HANGUP	  =	'000002CC'X)
	PARAMETER (SS$_NOPRIV	  =	'00000024'X)
	PARAMETER (SS$_NOTRAN	  =	'00000629'X)
	PARAMETER (SS$_NORMAL	  =	'00000001'X)
	PARAMETER (SS$_PARITY	  =	'000001F4'X)
	PARAMETER (SS$_TIMEOUT	  =	'0000022C'X)
C
C	End of COM.INC.
C
