.WAIT ^M$
!
! If no wait string is specified, we simply loop reading characters until
! we become idle.  The definition of idle is when we presume the remote
! isn't sending us any further data.  We presume we are idle when our
! remote read times out after 'n' seconds (1 by default).  The symbol
! SCRIPT_TMO can be defined to override this timeout.
!
! The remote read routine (READ_DATA) uses timeout count of 1 for the
! number of seconds allowed between receiving each character.  This can
! be overridden with the symbol IDLE_TMO.  If running in batch, you may
! want to increase this count to 2.
!
! Since many commands such as a "DIRECTORY" will have 2 seconds delays
! due to system load, you can specify a wait string.  In this command file,
! the wait string is defined as "^M$" which is the prompt used by VMS.
! The script loops up to 'n' times (5 by default) looking for this string.
! The symbol WAIT_TRYS can be defined to override this default.
!
! If the command line starts with an up arrow (^), all characters on the
! line with the ^char format are converted to control characters. This
! command file uses an "^Z" to terminate the CREATE command.
!
.WAIT
create test.dat
1
2
3
4
5
6
7
8
9
10
^Z
.WAIT ^M$
!
! The format of the .WAIT command is ".W[ait] string".  Characters of the
! form ^char are converted to control characters.  The string may contain
! contain embedded spaces but can not start with spaces.
!
SHOW TERMINAL
!
! Use the .W[ait] with no wait string to prevent script from looking for
! a wait string.  This is used when you want to send one line after another
! as in the CREATE command used in this command file.  The wait string can
! then be reenabled when you expect a prompt string.
!
.WAIT
create test1.dat
The .WAIT must be in uppercase to be found, otherwise the command is
sent to the remote system.
.wait string
.11
.12
.13
.14
.15
^Z
.WAIT ^M$
TYPE TEST.DAT,TEST1.DAT
DELETE *.DAT;*/LO
DIRECTORY
.W
LOGOUT
