C
C CHANGE is another default directory setting program.
C It should be defined as a foreign command.
C
C (c) Copyright 1983 Bryan J. Jensen
C     This software may be copied or distributed or changed to your
C     hearts content, just leave in the copyright notice.
C 
C Address any comments to:
C
C	Bryan Jensen
C	10 EEW
C	University Park, PA 16802
C
C	BITNET address: BJJ@PSUVMS1
C
C May 1983
C
	PROGRAM CHANGE
	IMPLICIT INTEGER (A-Z)
	INCLUDE '($SSDEF)'
	INCLUDE '($RMSDEF)'
	CHARACTER*132 CMD
	CHARACTER*64 DEV
	CHARACTER*100 DIR
	CHARACTER*132 SRH
	LOGICAL LOG

	CALL LIB$GET_FOREIGN (CMD, , CMDLEN, )
C
C Take care of /NOLOG qualifier the easy way
C
	IF (CMD(:MIN(6,CMDLEN)).EQ.'/NOLOG') THEN
	  CMD = CMD(7:CMDLEN)
	  CMDLEN = CMDLEN - 6
	  LOG = .FALSE.
	ELSE
	  LOG = .TRUE.			! Default is to log change
	END IF
C
C Eliminate any blanks which might be included in name
C
	IDX = 1					! Point into CMD
	DO WHILE (IDX .LE. CMDLEN)		! Repeat till end of line
	  IF (CMD(IDX:IDX).EQ.' ') THEN		! If blank,
	    CMD(IDX:CMDLEN) = CMD(IDX+1:CMDLEN)	! Remove it
	    CMDLEN = CMDLEN - 1			! And shorten line
	  ELSE					! If not blank,
	    IDX = IDX + 1			! Move to next character
	  END IF
	END DO
C
C Default directory is SYS$LOGIN
C
	IF (CMDLEN .EQ. 0) THEN
	  CMD = 'SYS$LOGIN'
	  CMDLEN = 9
	END IF
C
C Allow logical names to be specified without :
C Translate only if no : and no [] (translation fails if symbol has them)
C Devices (with :) will be properly parsed by RMS
C
	DO I = 1, 20				! Max translation level
	  STATUS = SYS$TRNLOG(CMD(:CMDLEN), DIRLEN, DIR, , , )
	  IF (.NOT.STATUS)  GO TO 7		! If no translation
	  IF (STATUS .EQ. SS$_NOTRAN) GO TO 7
	  CMD = DIR				! Use new name
	  CMDLEN = DIRLEN
	END DO
7	CONTINUE
C
C Provide [ ] around directory if omitted
C
	IF (CMD(CMDLEN:CMDLEN) .NE. ':') THEN	! No [ ] if only device spec
	  IF (INDEX(CMD(:CMDLEN), '[') .EQ. 0) THEN	! If no [,
	    DO IDX = CMDLEN, 1, -1		! Search for device end
	      IF (CMD(IDX:IDX) .EQ. ':') GO TO 10	! allowing for node::device:
	    END DO				! or device: or node::
	    IDX = 0				! No device
10	    IDX = IDX+1				! Point to directory

	    CMD(IDX:CMDLEN+1) = '['//CMD(IDX:CMDLEN)
	    CMDLEN = CMDLEN + 1			! Insert [ before directory
	  END IF

	  IF (INDEX(CMD(:CMDLEN), ']') .EQ. 0) THEN	! If no ],
	    CMDLEN = CMDLEN + 1			! Add ] to end
	    CMD(CMDLEN:CMDLEN) = ']'
	  END IF
	END IF
C
C Change + to - (- gets confused with DCL line continuation, so we allow +
C
	DO I = 1, CMDLEN
	  IF (CMD(I:I) .EQ. '+') CMD(I:I) = '-'
	END DO
C
C Allow for people using the form CHANGE ..DIR instead of CHANGE -.DIR
C
	IDX =INDEX (CMD(:CMDLEN), '..')		! Check for .. or ...
	IF (IDX .NE. 0) THEN
	  DOTCNT = 0				! Count number of dots
	  DO I = IDX, CMDLEN
	    IF (CMD(I:I) .NE. '.') GO TO 13
	    DOTCNT = DOTCNT +  1
	  END DO
13	  CONTINUE

	  IF (DOTCNT .NE. 3) THEN		! 3 dots are ok by VMS
	    IF (MOD(DOTCNT,2) .NE. 0) THEN
	      TYPE *, DOTCNT,' dots in a row is meaningless'
	      CALL EXIT
	    END IF
C
C Number of dots to remove.  Half of them unless there are deeper directories
C specified, then keep an extra dot. ([..] becomes [-], [..X] becomes [-.X])
C
	    REMOVE = DOTCNT/2			! Number of chars to remove
	    IF (IDX+DOTCNT .NE. CMDLEN) REMOVE = REMOVE -1

	    CMD(IDX:CMDLEN) = CMD(IDX+REMOVE:CMDLEN)	! Shorten spec
	    CMDLEN = CMDLEN - REMOVE		! Leaving one of the dots in
	    DO I = IDX, IDX+DOTCNT/2-1		! Replace .. with -
	      CMD(I:I) = '-'
	    END DO
	  END IF

	END IF
C
C Allow for a search list (If directory not found on current disk,
C look on other disks specified by user with SEARCH_LIST symbol.
C This is only done if no device was specified
C
	IF (INDEX(CMD(:CMDLEN),':') .EQ. 0) THEN
	  STATUS = SYS$TRNLOG ('SEARCH_LIST', SRHLEN, SRH, , , )
	  IF (.NOT.STATUS) SRHLEN = 0	! If no symbol
	  IF (STATUS .EQ. SS$_NOTRAN) SRHLEN = 0
	ELSE
	  SRHLEN = 0			! Device specified, don't search
	END IF
	SRH(SRHLEN+1:) = ' '		! Pad with blanks
	SRHDEVLEN = 0			! Initially, try no default
	FIRST_STATUS = 0		! Remember first search error
C
C Parse the spec and locate directory
C If the directory is empty, wild cards may not be used to get there
C (hopefully, no one will notice this, it sure makes life easier).
C
80	IDX = 0
	STATUS = LIB$FIND_FILE (CMD(:CMDLEN), DIR, IDX, '*.*', SRH(:SRHDEVLEN))
	IF (FIRST_STATUS .EQ. 0) FIRST_STATUS = STATUS

	IF (STATUS.NE.RMS$_FNF) THEN	! File not found ok (empty directory)
	  IF (.NOT.STATUS) THEN

	    IF (SRHLEN .GT. 0) THEN	! Maybe another disk
	      SRH = SRH(SRHDEVLEN+1:SRHLEN)	! Bring over next device
	      SRHLEN = SRHLEN - SRHDEVLEN
	      SRHDEVLEN = LIB$INDEX (SRH(:SRHLEN), ':')
	    END IF

	    IF (SRHDEVLEN .EQ. 0) THEN	! If no devices to search,
	      CALL LIB$STOP (%VAL(FIRST_STATUS))
	    END IF
	    GO TO 80			! Try again

	  END IF
	END IF

	DIRLEN = INDEX (DIR, ']')

	IF (LOG) TYPE *, DIR(:DIRLEN)

C
C Set the device
C
	IDX = INDEX (DIR(:DIRLEN), '[') - 1		! Separate device/directory

	STATUS = LIB$SET_LOGICAL ('SYS$DISK', DIR(:IDX))
	IF (.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))
C
C Set the directory
C
	STATUS = SYS$SETDDIR (DIR(IDX+1:DIRLEN),,)
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))

	END
