
  VAX TIMING ROUTINES: SAMPIN, SAMPON, SAMPOF, SAMPSW, SAMPDI

  WRITTEN BY L. H. LOWE, LOS ALAMOS, 06/04/82

  INITIALIZE TIMING SYSTEM:

     COMMON /SAMPBK/ IDUMMY
       . . .
     CALL SAMPIN(MX)

      MX IS UPPER LIMIT ON NUMBER OF CODE INTERVALS TO BE TIMED
      DIMENSION OF IDUMMY IS AT LEAST 5*MX

  BEGIN INTERVAL TO BE TIMED:

     CALL SAMPON(NAME)

      NAME IS INTERVAL NAME, 8H FORMAT

  END INTERVAL (RETURN TO PREVIOUS INTERVAL):

     CALL SAMPOF

    NOTE: TWO SUCCESSIVE CALLS TO SAMPON IMPLY THAT SECOND
      INTERVAL IS NESTED IN FIRST; E.G., A SUBROUTINE.
      IN THIS SENSE, SAMPOF CORRESPONDS TO A RETURN.
      FOLLOWING ROUTINE SWITCHES INTERVAL WITHOUT NESTING.

  SWITCH TO NEW INTERVAL:

     CALL SAMPSW(NAME)

      NAME IS NEW INTERVAL NAME, 8H FORMAT

  DISPLAY TIMING INFORMATION:

     CALL SAMPDI(LU)

      LU IS UNIT NUMBER ON WHICH INFORMATION IS WRITTEN

     SUBROUTINE SAMPIN(MXBLKS)

    SAMPIN INITIALIZES SAMPLING
      MXBLKS - MAX NUMBER OF INTERVALS

    REQUIRES COMMON /SAMPBK/ IS(K)
      WHERE K IS AT LEAST 5*MXBLKS

     COMMON/SAMPBK/IS(1)
     COMMON/SAMPB2/MINST,KURST,MAXST,MINBK,KURBK,MAXBK,ITIMEA,ITIMEB,
    +LONG(4)
     INTEGER*2SHORT(2)
     EQUIVALENCE(LONG,SHORT)
  SET UP TIMING BLOCK
     SHORT(1)=4
     SHORT(2)='2007'O
     LONG(3)=0
     LONG(4)=0
  SET UP VARIABLES
     MINST=1
     KURST=0
     MAXST=MXBLKS
     MINBK=MXBLKS+1
     KURBK=MINBK-4
     MAXBK=KURBK+4*MXBLKS
  GET START TIME
     LONG(2)=%LOC(ITIMEA)
     CALL SYS$GETJPI(,,,LONG,,,)
     RETURN
     END
     SUBROUTINE SAMPON(NAME)
     COMMON/SAMPBK/IS(1)
     COMMON/SAMPB2/MINST,KURST,MAXST,MINBK,KURBK,MAXBK,ITIMEA,ITIMEB,
    +LONG(4)
     INTEGER*2SHORT(2)
     EQUIVALENCE(LONG,SHORT)

    NEST INTERVAL (NAME)
      NAME - INTERVAL NAME, 8H FORMAT

     DIMENSION NAME(2)
     INTEGER SAMPCP
  GET TIME
     LONG(2)=%LOC(ITIMEB)
     CALL SYS$GETJPI(,,,LONG,,,)
  ACCUMULATE TIME INTO CURRENT BLOCK
     IF(KURST.GE.MINST)THEN
     I=IS(KURST)
     IS(I+2)=IS(I+2)+ITIMEB-ITIMEA
     END IF
  BUMP STACK POINTER
     ITIMEA=ITIMEB
     KURST=KURST+1
     IF(KURST.GT.MAXST)GO TO 800
  SORT NAME INTO LIST
     DO 99999 I=MINBK,KURBK,4
     IF(SAMPCP(NAME,IS(I)))99998,99997,99999
9999 CONTINUE
    ADD NAME AT END
     I=KURBK+4
     GO TO 99996
    PUSH NAME INTO POSITION I
9998 IF(KURBK.GT.MAXBK-4)GO TO 800
     J=KURBK+8
     DO 99995 K=I,KURBK,4
     DO 99994 L=1,4
     J=J-1
     IS(J)=IS(J-4)
9994 CONTINUE
9995 CONTINUE
     DO 99993 K=MINST,KURST
     L=IS(K)
     IF(L.GE.I)IS(K)=L+4
9993 CONTINUE
9996 KURBK=KURBK+4
     IF(KURBK.GT.MAXBK)GO TO 800
     IS(I)=NAME(1)
     IS(I+1)=NAME(2)
     IS(I+2)=0
     IS(I+3)=0
  MATCH FOUND
9997 IS(KURST)=I
     IS(I+3)=IS(I+3)+1
     RETURN
  ERROR
00   CALL LIB$PUT_OUTPUT('sampon block or stack overflow')
     STOP
     END
     SUBROUTINE SAMPOF

    UNSTACK CURRENT INTERVAL

     COMMON/SAMPBK/IS(1)
     COMMON/SAMPB2/MINST,KURST,MAXST,MINBK,KURBK,MAXBK,ITIMEA,ITIMEB,
    +LONG(4)
     INTEGER*2SHORT(2)
     EQUIVALENCE(LONG,SHORT)

     IF(KURST.LT.MINST)THEN
     CALL LIB$PUT_OUTPUT('sampof stack empty')
     STOP
     END IF
     LONG(2)=%LOC(ITIMEB)
     CALL SYS$GETJPI(,,,LONG,,,)
     I=IS(KURST)
     IS(I+2)=IS(I+2)+ITIMEB-ITIMEA
     ITIMEA=ITIMEB
     KURST=KURST-1
     RETURN
     END
     SUBROUTINE SAMPSW(NAME)
     COMMON/SAMPBK/IS(1)
     COMMON/SAMPB2/MINST,KURST,MAXST,MINBK,KURBK,MAXBK,ITIMEA,ITIMEB,
    +LONG(4)
     INTEGER*2SHORT(2)
     EQUIVALENCE(LONG,SHORT)

    SWITCH INTERVAL TO (NAME)
      NAME - 8H FORMAT

     DIMENSION NAME(2)
     INTEGER SAMPCP

     IF(KURST.LT.MINST)THEN
     CALL LIB$PUT_OUTPUT('sampsw stack empty')
     STOP
     END IF
     LONG(2)=%LOC(ITIMEB)
     CALL SYS$GETJPI(,,,LONG,,,)
     I=IS(KURST)
     IS(I+2)=IS(I+2)+ITIMEB-ITIMEA
     ITIMEA=ITIMEB
  SORT NAME INTO LIST
     DO 99999 I=MINBK,KURBK,4
     IF(SAMPCP(NAME,IS(I)))99998,99997,99999
9999 CONTINUE
    ADD NAME AT END
     I=KURBK+4
     GO TO 99996
    PUSH NAME INTO POSITION I
9998 IF(KURBK.GT.MAXBK-4)GO TO 800
     J=KURBK+8
     DO 99995 K=I,KURBK,4
     DO 99994 L=1,4
     J=J-1
     IS(J)=IS(J-4)
9994 CONTINUE
9995 CONTINUE
     DO 99993 K=MINST,KURST
     L=IS(K)
     IF(L.GE.I)IS(K)=L+4
9993 CONTINUE
9996 KURBK=KURBK+4
     IF(KURBK.GT.MAXBK)GO TO 800
     IS(I)=NAME(1)
     IS(I+1)=NAME(2)
     IS(I+2)=0
     IS(I+3)=0
  MATCH FOUND
9997 IS(KURST)=I
     IS(I+3)=IS(I+3)+1
     RETURN
  ERROR
00   CALL LIB$PUT_OUTPUT('sampsw block or stack overflow')
     STOP
     END
     SUBROUTINE SAMPDI(LU)

    WRITE SUMMARY
      LU - UNIT TO WRITE

     COMMON/SAMPBK/IS(1)
     COMMON/SAMPB2/MINST,KURST,MAXST,MINBK,KURBK,MAXBK,ITIMEA,ITIMEB,
    +LONG(4)
     INTEGER*2SHORT(2)
     EQUIVALENCE(LONG,SHORT)

     IF(KURST.NE.0)THEN
     LONG(2)=%LOC(ITIMEB)
     CALL SYS$GETJPI(,,,LONG,,,)
     I=IS(KURST)
     IS(I+2)=IS(I+2)+ITIMEB-ITIMEA
     ITIMEA=ITIMEB
     END IF
     TOTIME=0.
     DO 99999 I=MINBK,KURBK,4
     TOTIME=TOTIME+AMAX1(12.5*FLOAT(IS(I+2))-FLOAT(IS(I+3)),0.)/1250.
9999 CONTINUE
     WRITE(LU,13)TOTIME3    FORMAT(' estimated original execution time ',F10.2,/,
    +' interval   samples   %    count',/)
     DO 99998 I=MINBK,KURBK,4
     IPC=AMAX1(FLOAT(IS(I+2))-FLOAT(IS(I+3))/12.5,0.)/TOTIME+.5
     WRITE(LU,23)IS(I),IS(I+1),IS(I+2),IPC,IS(I+3)
9998 CONTINUE
3    FORMAT(1X,2A4,1X,I10,1X,I2,1X,I10)
     RETURN
     END
     INTEGER FUNCTION SAMPCP(INEW,IOLD)
     LOGICAL*1INEW(8),IOLD(8)

    DO ASCII COMPARISON

     DO 99999 I=1,8
     SAMPCP=INEW(I)-IOLD(I)
     IF(SAMPCP.NE.0)RETURN
9999 CONTINUE
     RETURN
     END