$!	Backup.com
$!		originally by Robert Wright
$!		grossly modified by J.James Belonis II
$!		merged with Dick Seymour's VAXBACKUP for defaults 6/15/83
$!	allows tape allocated or not, mounted or not
$!
$ on error then goto exit
$ on control_y then goto exit
$ ws:=write sys$output
$ BACKUP:=BACKUP  ! in case the user has re-defined BACKUP as this command file
$ COPY:=COPY
$ TOTAPE:="D"
$ MOUNTED:="FALSE"
$ MOUNTEDFOR:="FALSE"
$ ws  "    This is a utility for moving files to/from a magnetic tape"
$ ws  "as a BACKUP save-set (a group of files in one container file)"
$ ws  "or as individual files.  Commands may be abbreviated to 1 character."
$BEGIN:
$ INQUIRE/NOPUN TAPEDRIVE "Which tape drive A0,B0,B1,DISK ?(default B0) "
$ if TAPEDRIVE.eqs."" then TAPEDRIVE:="B0"
$ DISKTODISK:="''F$EXTRACT(0,1,TAPEDRIVE)'"
$ IF DISKTODISK.eqs."D" THEN GOTO DISK
$ TAPEDRIVE:="_MT''TAPEDRIVE'"

$ IF "''F$GETDVI(TAPEDRIVE,"ALL")'" THEN GOTO ALLOCATED
$ ALLOCATE  'TAPEDRIVE:  TAPE
$ALLOCATED:
$ IF "''F$GETDVI(TAPEDRIVE,"MNT")'" THEN GOTO MOUNTED
$ MOUNT/FOREIGN  'TAPEDRIVE:
$MOUNTED:
$ LABEL:='F$GETDVI(TAPEDRIVE,"VOLNAM")
$ DISM/NOUNL  TAPE:
$ MOUNTED:="FALSE"		! not mounted labeled
$ MOUNTEDFOR:="FALSE"		! not mounted foreign
$!	now tape is in standard condition
$!	dismounted rewound, but known label if it exists.
$!
$TOFROM:
$ INQUIRE/NOPUN TOTAPE "TO or FROM tape ?(default TO)"
$ IF TOTAPE.eqs."" then  TOTAPE:="TO"
$ TOTAPE:="''F$EXTRACT(0,1,TOTAPE)'"
$ IF TOTAPE  THEN TOFROM:="TO"
$ IF .not.TOTAPE  THEN TOFROM:="FROM"
$ IF .not.TOTAPE THEN GOTO DIRECTIONS
$ INQUIRE/NOPUN ANS   "OK to erase tape (INITIALIZE) ?(default NO) "
$ IF .not.ANS THEN GOTO DIRECTIONS

$ INITIALIZE:

$ INQUIRE/NOPUN ANS "I WILL DESTROY EVERYTHING ON THE TAPE.  ARE YOU SURE? "
$ IF .not.ANS THEN GOTO DIRECTIONS
$ IF MOUNTED.or.MOUNTEDFOR THEN DISMOUNT/NOUNL  TAPE:
$ ws  "What label would you like up to 6 characters?(default TAPE)"
$ INQUIRE/NOPUN LABEL "Examples:  TURKEY  or  MAY13 ? "
$ IF LABEL.eqs."" then LABEL:=TAPE
$ inquire/nopun density "What density in bits per inch ?(default 1600) "
$ if "''density'".eqs."" then  density=1600
$ INITIALIZE/DENSITY='density  TAPE:  'LABEL
$ TOTAPE:="T"
$ TOFROM:="TO"
$ GOTO DIRECTIONS

$NOLABEL:
$ ws  "This tape has NO LABEL.  Try a different utility."
$ goto exit

$DIRECTIONS:
$ IF "''LABEL'".eqs."" THEN GOTO NOLABEL
$ ws  " "
$ WS  "BACKUP     = BACKUP files ''TOFROM' save-sets on tape"
$ WS  "COPY       = COPY files ''TOFROM' files on tape"
$ WS  "LIST       = List names of files or save-sets"
$ ws  "TO-FROM    = change copy/backup direction."
$ ws  "INITIALIZE = INITIALIZE tape (erase it)"
$ WS  "DISK       = OOPS, I really want disk to disk manipulations"
$! WS  "HELP       = Examples of full commands"
$ WS  "EXIT       = Terminates command procedure"
$ INQUIRE/NOPUN OPT "?(default BACKUP) "
$ opt:="''f$extract(0,1,opt)'"
$ IF OPT .EQS. ""  THEN GOTO DUMP
$ IF OPT .EQS. "B" THEN GOTO DUMP
$ IF OPT .EQS. "C" THEN GOTO COPY
$ IF OPT .EQS. "L" THEN GOTO LIST
$ IF OPT .EQS. "T" THEN GOTO TOFROM
$ IF OPT .EQS. "I" THEN GOTO INITIALIZE
$ IF OPT .EQS. "D" THEN GOTO DISKOOPS
$ IF OPT .EQS. "H" THEN GOTO HELP
$ IF OPT .EQS. "E" THEN GOTO EXIT
$ ws  "huh?"
$ GOTO DIRECTIONS

$DISKOOPS:
$ DISKTODISK:="D"
$ GOTO DISK


$DUMP:		! Backup to/from tape
$ IF .not.TOTAPE THEN GOTO RESTORE

$COPY_SAVE_SETS:	! to tape
$ ws  " "
$ inquire/nopun files "BACKUP which disk files to tape ?(default *.*;*) "
$ if files.eqs."" then  files:=*.*;*
$notall:
$ write sys$output "Down from which directory ?"
$               dir:="SYS$LOGIN"
$               dir:='f$logical(dir)
$               s2='f$length(dir)
$               s2=s2-1
$               dir:='f$extract(0,s2,dir)
$               dirdef:='dir'"...]"
$ inquire/nopun dir "(default ''dirdef') "
$ if dir.eqs."" then  dir:='dirdef
$ ws  " "
$askmore:
$ daytime:='f$time()
$ pos:='f$locate("-",daytime)
$ month:='f$extract(pos+1,3,daytime)
$ day:='f$extract(0,pos,daytime)
$ defset=month+day+".BCK"
$ write sys$output "What shall I call the save-set container file ?"
$ inquire/nopun set  "(default ''defset')"
$ if set.eqs."" then  set:='defset
$ if .not.MOUNTEDFOR then  goto mountbackup
$mountedbackup:
$ ws  "$ BACKUP/NOREWIND  ''DIR'  ''TAPEDRIVE':''SET'"
$ BACKUP/NOREWIND/LOG  'DIR  TAPE:'SET
$ GOTO DIRECTIONS

$mountbackup:		! not mounted /FOREIGN
$ IF MOUNTED THEN  DISMOUNT/NOUNL  TAPE:
$ MOUNT/FOREIGN  TAPE:
$ MOUNTED:="TRUE"
$ MOUNTEDFOR:="TRUE"
$ GOTO mountedbackup


$RESTORE:		! disk files from save-set
$ ws  " "
$ setdef=label+".BCK"
$ write sys$output "From which save-set container file on tape ?"
$ inquire/nopun set  "(default ''setdef')"
$ if set.eqs."" then  set:='setdef'
$!
$ write sys$output "Which files shall I restore to disk ?"
$ write sys$output "Example: [TURKEY...]*.FOR;1"
$ inquire/nopun files "(default *.*;*) "
$ if files.eqs."" then  files:=*.*;*
$!
$ write sys$output "Into which directory ?
$ dirdef="''f$logical("SYS$DISK")'"+"''f$directory()'"-"]"+"...]"
$ inquire/nopun dir "(default ''dirdef') "
$ if dir.eqs."" then  dir:='dirdef
$ ws  " "
$ if files.nes."*.*;*" then  set:="''set'/SELECT=''files'"
$ IF MOUNTED.and..not.MOUNTEDFOR THEN  DISMOUNT/NOUNLOAD  TAPE:
$ IF .not.MOUNTEDFOR THEN  MOUNT/FOREIGN  TAPE:
$ ws "$ BACKUP/NOREWIND  ''TAPEDRIVE':''SET'  ''DIR'"
$ BACKUP/NOREWIND  TAPE:'SET  'DIR
$ goto DIRECTIONS


$COPY:
$ ws  " "
$ IF .not.TOTAPE THEN GOTO FILES_SAVED

$COPY_FILES:
$ ws  "Files to COPY TO tape:"
$ ws  "To COPY all files including all subdirectories to tape '[...]*.*'"
$ ws  "To COPY files from a particular subdirectory  '[.BASIC]*.*'"
$ INQUIRE/NOPUN OPT "(default *.*;*) "
$ IF "''OPT'".EQS."" THEN  OPT:=*.*;*
$ IF MOUNTEDFOR THEN  DISMOUNT/NOUNL  TAPE:
$ IF .not.MOUNTED THEN  MOUNT  TAPE:  'LABEL
$ MOUNTED:="TRUE"
$ MOUNTEDFOR:="FALSE"
$ WS "COPY  ''OPT  ''TAPEDRIVE':"
$ COPY  'OPT  TAPE:
$ GOTO DIRECTIONS

$FILES_SAVED:		! COPY files from tape to disk
$ ws  "Files to be COPYed FROM tape:"
$ ws  "EXAMPLES: '*.FOR;*' or '*.COM;*,*.MAI;*'"
$ INQUIRE/NOPUN SAVE "(default *.*;*) "
$ IF "''SAVE'".eqs."" then SAVE:=*.*;*
$ ws  " "
 write sys$output "Into which directory ?
$ dirdef="''f$logical("SYS$DISK")'"+"''f$directory()'"
$ inquire/nopun dir "(default ''dirdef') "
$ if dir.eqs."" then  dir:='dirdef
$ ws  " "
$ IF MOUNTEDFOR THEN  DISMOUNT/NOUNL  TAPE:
$ IF .not.MOUNTED THEN  MOUNT  TAPE:  'LABEL
$ MOUNTED:="TRUE"
$ MOUNTEDFOR:="FALSE"
$ WS "COPY  ''TAPEDRIVE':''SAVE'  ''DIR'"
$ COPY  TAPE:'SAVE  'DIR
$ GOTO DIRECTIONS
 

$DISK:		! BACKUP disk to disk
$ ws  "Files to COPY from disk to disk:"
$ ws  "EXAMPLES: '*.FOR;*' or '*.COM;*,*.MAI;*'"
$ INQUIRE/NOPUN SAVE "(default *.*;*) "
$ IF "''SAVE'".eqs."" then SAVE:=*.*;*
$ ws  " "
$ ws  "FROM which directory ?"
$ dirdef="''f$logical("SYS$DISK")'"+"''f$directory()'"-"]"+"...]"
$ inquire/nopun FROM "(default ''dirdef') "
$ if "''FROM'".eqs."" then  FROM:='dirdef
$ ws  " "
$ write sys$output "TO which directory ?"
$ inquire/nopun TO "(default ''dirdef') "
$ if "''TO'".eqs."" then  TO:='dirdef
$ ws  " "
$ ws  "$ BACKUP  ''FROM'","''SAVE  ''TO'"
$ BACKUP  'FROM''SAVE'  'TO
$ GOTO BEGIN
 
$LIST:
$ ws  " "
$ ws  "Enter Type Of Listing"
$ ws  "----------------------------"
$ ws  "FILES = Files on tape"
$ ws  "SAVE  = Files in a save-set on tape"
$ ws  "END   = Done with this segment"
$ INQUIRE/NOPUN OPT "(default SAVE) "
$ OPT:="''F$EXTRACT(0,1,OPT)'"
$ IF OPT .EQS. ""  THEN GOTO DIRECTORY_OF_FILES
$ IF OPT .EQS. "F" THEN GOTO DIRECTORY_OF_FILES
$ IF OPT .EQS. "S" THEN GOTO DIRECTORY_OF_SAVE_SETS
$ IF OPT .EQS. "E" THEN GOTO DIRECTIONS
$ GOTO LIST

$DIRECTORY_OF_FILES:
$ IF MOUNTEDFOR THEN  DISMOUNT/NOUNL  TAPE: 
$ IF .not.MOUNTED  THEN  MOUNT  TAPE:  'LABEL
$ MOUNTED:="TRUE"
$ MOUNTEDFOR:="FALSE"
$ DIRECTORY  TAPE:
$ GOTO LIST

$DIRECTORY_OF_SAVE_SETS:
$ ws  "Enter Save-Set Name"
$ ws  "Example: 'JUN17.BCK'"
$ INQUIRE/NOPUN ANS "(default TAPE.BCK) "
$ IF "''ANS'".EQS."" THEN ANS:=TAPE.BCK
$ IF MOUNTED.and..not.MOUNTEDFOR  THEN DISMOUNT/NOUNL  TAPE:
$ IF .not.MOUNTEDFOR  THEN MOUNT/FOR  TAPE:
$ MOUNTED:="FALSE"
$ MOUNTEDFOR:="TRUE"
$ WS  "$ BACKUP/NOREWIND/LIST  ''TAPE'","''ANS'"
$ BACKUP/NOREWIND/LIST TAPE:'ANS
$ GOTO LIST
 
$HELP:
$ ws  " "
$ ws  "Sorry no HELP for the wicked."
$ GOTO DIRECTIONS

$EXIT:
$ IF TOTAPE.EQS."D" THEN EXIT
$ ws  "UNLOAD and deallocate tape drive for tape removal"
$ INQUIRE/NOPUN UNLOAD " or just REWIND ?(default UNLOAD)"
$ UNLOAD:="''F$EXTRACT(0,1,UNLOAD)'"
$!  assume it is all screwed up from an error
$ MOUNTED:="FALSE"
$ MOUNTEDFOR:="FALSE"
$ IF "''F$GETDVI(TAPEDRIVE,"ALL")'" THEN GOTO ALLOCATED2
$ ALLOCATE  'TAPEDRIVE:  TAPE
$ALLOCATED2:
$ IF "''F$GETDVI(TAPEDRIVE,"MNT")'" THEN GOTO MOUNTED2
$ MOUNT/FOREIGN  'TAPEDRIVE:
$MOUNTED2:
$ IF UNLOAD.eqs."U" THEN DISMOUNT  TAPE:
$ IF UNLOAD.eqs."R" THEN DISMOUNT/NOUNLOAD  TAPE:
$DEAL:
$ IF UNLOAD.eqs."U" THEN DEALLOCATE  TAPE:
$ EXIT
